! NOTE 1: RMSD is undefined for QG estimator of DD dyads at a biallelic locus,
!         and for LR estimator of DD dyads at a biallelic locus with q1=q2=1/2
! NOTE 2: When compiled by Ifort, do not use options /O3 or /fast   
!
Module Variables 
  INTEGER,PARAMETER:: DP=SELECTED_REAL_KIND(P=13)
  REAL(DP),PARAMETER:: Small=1.E-20_DP,TINY=1.e-300_DP
  REAL(DP):: BETA(0:3),Sig_Level,TAO(0:2),Prec1
  REAL(DP),ALLOCATABLE:: PHI(:),DELTA(:),ErrorRate(:)
  INTEGER,ALLOCATABLE:: MarkerType(:)
  INTEGER:: Ploidy2,NPairSimu,MaxLength,NumberR, IDUM
END Module Variables 

PROGRAM MAIN 
  USE VARIABLES
  INTEGER::NumLoci,MaxNumAllele,I_SEED(1),NT(12)
  INTEGER,ALLOCATABLE:: NumAllele(:),inx(:,:)
  REAL(DP):: X,MinPrec,SD(12,2)
  REAL(DP),ALLOCATABLE:: AlleleFre(:,:),KinshipInfor(:),RMSD(:,:), &
    RelatedInfor(:),Threshould(:),Power(:),ThreshouldSimu(:), &
    PowerSimu(:),ExclProb(:)
  REAL(DP),ALLOCATABLE:: wksp1(:,:),wksp2(:),wksp3(:),wksp4(:),wksp5(:)
  REAL(DP):: spear_r(20,20),tem(9) 
  CHARACTER(Len=10),ALLOCATABLE:: MarkerID(:)
  CHARACTER*16:: OutFileName  
  CHARACTER*263:: temchar1,temchar2
  CHARACTER*133:: LINE  
  INTEGER:: I,J,K,L,N,JJ
  EXTERNAL:: RelationshipInfor,RMSDsub,RelatednessInfor,PowerSub,INDEXX
  OPEN(UNIT=10,FILE='KININFOR.DAT',IOSTAT=IOS,ERR=1,STATUS='OLD')  
  READ(10,*,IOSTAT=IOS,ERR=9,End=9)OutFileName
  READ(10,*,IOSTAT=IOS,ERR=9,End=9)Ploidy2  
  READ(10,*,IOSTAT=IOS,ERR=9,End=9)NumberR  
  IF(NumberR<2)THEN
    WRITE(*,*)'The number of relationships should be greater than 1.'
    GOTO 9
  ENDIF  
  ALLOCATE(PHI(NumberR),DELTA(NumberR)) 
  DO I=1,NumberR  
    IF(Ploidy2==4)THEN
      READ(10,*,IOSTAT=IOS,ERR=9,End=9)PHI(I),DELTA(I)
    ELSEIF(Ploidy2==3)THEN
      READ(10,*,IOSTAT=IOS,ERR=9,End=9)PHI(I)
    ELSEIF(Ploidy2==2)THEN
      READ(10,*,IOSTAT=IOS,ERR=9,End=9)DELTA(I)
    ELSE
      WRITE(*,*)'Incorrect indicator for DD(4), DH(3) or HH(2) dyads'
      GOTO 9  
    ENDIF
  ENDDO
  K=0
  LOOP1: DO I=1,NumberR
    DO J=I+1,NumberR
      IF(PLOIDY2==4)THEN
        IF(ABS(PHI(I)-PHI(J))<TINY.AND.ABS(DELTA(I)-DELTA(J))<TINY)K=1
      ELSEIF(PLOIDY2==3)THEN
        IF(ABS(PHI(I)-PHI(J))<TINY) K=1     
      ELSE
        IF(ABS(DELTA(I)-DELTA(J))<TINY) K=1      
      ENDIF
      IF(K==1) EXIT LOOP1      
    ENDDO
  ENDDO LOOP1
  IF(K==1)THEN
    write(*,'(A/A)') &
      'At least 2 relationships to be distinguished are identical.', &
      ' Do you want to proceed?(Y/N)'
    READ(*,*)temchar1
    IF(temchar1(1:1)=='N'.or.temchar1(1:1)=='n')THEN
      WRITE(*,*)'Program stopped'
      CALL DelayedExit(2.0)
    ENDIF
  ENDIF      
  IF(Ploidy2==4)THEN
    READ(10,*,IOSTAT=IOS,ERR=9,End=9)(BETA(I),i=2,0,-1) 
    BETA(3)=SUM(BETA(0:2))    
  ELSEIF(Ploidy2==3)THEN
    READ(10,*,IOSTAT=IOS,ERR=9,End=9)BETA(1),BETA(0)  
    BETA(3)=BETA(0)+BETA(1)    
  ELSE
    READ(10,*,IOSTAT=IOS,ERR=9,End=9)BETA(2),BETA(0) 
    BETA(3)=BETA(0)+BETA(2)    
  ENDIF      
  IF((PLOIDY2==4.AND.MINVAL(BETA(0:2))<0.5).OR. &
     (PLOIDY2==3.AND.(BETA(0)<0.5.OR.BETA(1)<0.5)).OR. &
     (PLOIDY2==2.AND.(BETA(0)<0.5.OR.BETA(2)<0.5)))THEN
    write(*,'(A/A)') &
      'The prior BETA or Dirichlet distribution is too steep that the', &
      '  integration may fail or be inacurate.  Do you want to proceed?(Y/N)' 
    READ(*,*)temchar1
    IF(temchar1(1:1)=='N'.or.temchar1(1:1)=='n')THEN
      WRITE(*,*)'Program stopped'
      CALL DelayedExit(2.0)
    ENDIF      
  ENDIF
  READ(10,*,IOSTAT=IOS,ERR=9,End=9)Sig_Level 
  READ(10,*,IOSTAT=IOS,ERR=9,End=9)Prec1
  READ(10,*,IOSTAT=IOS,ERR=9,End=9)MaxLength
  READ(10,*,IOSTAT=IOS,ERR=9,End=9)NPairSimu
  READ(10,*,IOSTAT=IOS,ERR=9,End=9)I_SEED(1)  
  IDUM=I_SEED(1) 
  READ(10,*,IOSTAT=IOS,ERR=9,End=9)NumLoci     
  READ(10,*,IOSTAT=IOS,ERR=9,End=9)MaxNumAllele
  ALLOCATE(NumAllele(NumLoci),ErrorRate(NumLoci),MarkerType(NumLoci), &
    MarkerID(NumLoci),AlleleFre(MaxNumAllele, NumLoci),INX(12,NumLoci))    
  DO I=1,NumLoci 
    READ(10,*,IOSTAT=IOS,ERR=9,End=9)MarkerID(I)   
    READ(10,*,IOSTAT=IOS,ERR=9,End=9)MarkerType(I) 
    READ(10,*,IOSTAT=IOS,ERR=9,End=9)ErrorRate(I)         
    IF(ErrorRate(I)<1.E-5_DP)ErrorRate(I)=1.E-5_DP 
    READ(10,*,IOSTAT=IOS,ERR=9,End=9)NumAllele(I)    
    IF(NumAllele(I)<2)THEN
      WRITE(*,'(A,A,A/A)')'Locus ',MarkerID(I), &
        ' has only ONE allele.','Program stopped!'
      CALL DelayedExit(2.0)
    ELSEIF(NumAllele(I)>2.AND.MarkerType(I)==2)THEN
      WRITE(*,'(A,A,A/A)')'Locus ',MarkerID(I), &
        ' is dominant, but has more than 2 alleles.','Program stopped!'
      CALL DelayedExit(2.0)
    ENDIF
    READ(10,*,IOSTAT=IOS,ERR=9,End=9) (AlleleFre(J, I),J=1,NumAllele(I))
    X=SUM(AlleleFre(1:NumAllele(I), I))  
    IF(X<0.99.OR.X>1.01)THEN
      WRITE(*,'(A,A,A/A)')'Locus ',MarkerID(I), &
        ' has allele frequencies that do not sum to 1.','Program stopped!'
      CALL DelayedExit(2.0)
    ENDIF
    K=0
    DO J=NumAllele(I),1,-1
      IF(AlleleFre(J, I)<Small)THEN
        K=K+1
        DO L=J,NumAllele(I)-K
          AlleleFre(L, I)=AlleleFre(L+1, I)
        ENDDO
      ENDIF
    ENDDO  
    NumAllele(I)=NumAllele(I)-K        
  ENDDO   
  close(10)   
  ALLOCATE(KinshipInfor(NumLoci),RMSD(5,0:NumLoci),RelatedInfor(NumLoci), &
    Threshould(0:NumLoci),Power(0:NumLoci),ThreshouldSimu(0:NumLoci), &
    PowerSimu(0:NumLoci),ExclProb(0:NumLoci))
  ExclProb(0)=1._DP
  Do L=1,NumLoci
    WRITE(*,'(A,I6,A,A,A,I6)') &
      'Locus ',L,'  :  ',MarkerID(L),' #Alleles=',NumAllele(L)
    CALL RelationshipInfor(NumAllele(L),ErrorRate(L),AlleleFre(:, L), &
      KinshipInfor(L),MarkerType(L))                     
    CALL RMSDsub(NumAllele(L),ErrorRate(L),AlleleFre(:, L),RMSD(:,L), &
      MarkerType(L))        
    CALL RelatednessInfor(NumAllele(L),ErrorRate(L),AlleleFre(:, L), &
      RelatedInfor(L),MarkerType(L))       
    CALL PowerSub(1,NumAllele(L),MaxNumAllele,AlleleFre(:, L),MinPrec, &
      Threshould(L),Power(L),ThreshouldSimu(L),PowerSimu(L), &
      MarkerType(L:L),ErrorRate(L:L))
                                ! Parentage exclusion probability
    IF(MarkerType(L)==1)THEN
      ExclProb(L)=0._DP
      DO J=1,NumAllele(L)  
        ExclProb(L)=ExclProb(L)+AlleleFre(j, L)*(1-AlleleFre(j, L))**2
        Do K=1,NumAllele(L)
          IF(K/=J)ExclProb(L)=ExclProb(L)-.5*(AlleleFre(j, L)* &
            AlleleFre(K, L))**2*(4._DP-3._DP*(AlleleFre(J, L)+AlleleFre(K, L)))
        ENDDO
      ENDDO
      ExclProb(0)=ExclProb(0)*(1-ExclProb(L))
    ELSE
      ExclProb(L)=-1._DP
    ENDIF
  ENDDO
  IF(NumLoci>1)THEN
    CALL PowerSub(NumLoci,NumAllele,MaxNumAllele,AlleleFre,MinPrec, &
        Threshould(0),Power(0),ThreshouldSimu(0),PowerSimu(0), &
        MarkerType,ErrorRate)
    IF(Any(MarkerType(:NumLoci)==1))THEN
      ExclProb(0)=1-ExclProb(0)
    ELSE
      ExclProb(0)=-1._DP
    ENDIF    
  ENDIF
! OUTPUT        
  DO I=1,133
    LINE(I:I)='-'
  ENDDO
  OPEN(UNIT=10,FILE=OutFileName)
  WRITE(10,'(A/T35,A/A)')LINE,'Output from KinInfor',LINE  
  temchar1='Locus            R_Infor    RMSD(LL)    RMSD(QG)     RMSD(R)'  
  IF(Ploidy2==4)THEN
    N=5
    IF(NPairSimu<1)THEN
      temchar2=TRIM(temchar1)//'    RMSD(LR)     RMSD(W)       Power     r_Infor    ExclProb'    
      temchar1=TRIM(temchar1)// &
           '    RMSD(LR)     RMSD(W)  Threshould       Power     r_Infor    ExclProb'
    ELSE 
      temchar2=TRIM(temchar1)// &
           '    RMSD(LR)     RMSD(W)       Power   SimuPower     r_Infor    ExclProb'      
      temchar1=TRIM(temchar1)// &
           '    RMSD(LR)     RMSD(W)  Threshould       Power SimuThrshld   SimuPower'&
         //'     r_Infor    ExclProb'   
    ENDIF
  ELSEIF(Ploidy2==3)THEN
    N=4
    IF(NPairSimu<1)THEN
      temchar2=TRIM(temchar1)//'    RMSD(LR)       Power     r_Infor    ExclProb'    
      temchar1=TRIM(temchar1)// &
           '    RMSD(LR)  Threshould       Power     r_Infor    ExclProb'
    ELSE 
      temchar2=TRIM(temchar1)// &
           '    RMSD(LR)       Power   SimuPower     r_Infor    ExclProb'      
      temchar1=TRIM(temchar1)// &
           '    RMSD(LR)  Threshould       Power SimuThrshld   SimuPower'&
         //'     r_Infor    ExclProb'   
    ENDIF
  ELSE
    N=3
    IF(NPairSimu<1)THEN
       temchar2=TRIM(temchar1)//'       Power     r_Infor    ExclProb'      
       temchar1=TRIM(temchar1)// &
           '  Threshould       Power     r_Infor    ExclProb' 
    ELSE 
       temchar2=TRIM(temchar1)//'       Power   SimuPower'// &
           '     r_Infor    ExclProb'    
       temchar1=TRIM(temchar1)// &
           '  Threshould       Power SimuThrshld   SimuPower'// &
           '     r_Infor    ExclProb'       
    ENDIF
  ENDIF     
  WRITE(10,'(A)')TRIM(temchar1) 
  IF(NPairSimu<1)THEN  
    JJ=0
  ELSE
    JJ=2
  ENDIF
  ALLOCATE(wksp1(JJ+5+N,NumLoci),wksp2(NumLoci),wksp3(NumLoci), &
    wksp4(NumLoci),wksp5(NumLoci))
  wksp1(1,:)=KinshipInfor(:)
  FORALL(J=1:N)wksp1(J+1,1:NumLoci)=RMSD(J,1:NumLoci)   
  wksp1(N+2,1:NumLoci)=Threshould(1:NumLoci)  
  wksp1(N+3,1:NumLoci)=Power(1:NumLoci) 
  IF(NPairSimu>0)THEN
    wksp1(N+4,1:NumLoci)=ThreshouldSimu(1:NumLoci)  
    wksp1(N+5,1:NumLoci)=PowerSimu(1:NumLoci)   
  ENDIF
  wksp1(JJ+N+4,:)=RelatedInfor(:)
  wksp1(JJ+N+5,1:NumLoci)=ExclProb(1:NumLoci)   
  DO I=1,NumLoci
    IF(Ploidy2==4)THEN
      IF(NPairSimu<1)THEN
        WRITE(10,21) ' {',MarkerID(I),wksp1(1:JJ+N+5,I),'},'
      ELSE 
        WRITE(10,22) ' {',MarkerID(I),wksp1(1:JJ+N+5,I),'},'      
      ENDIF
    ELSEIF(Ploidy2==3)THEN
      IF(NPairSimu<1)THEN
        WRITE(10,23) ' {',MarkerID(I),wksp1(1:JJ+N+5,I),'},'
      ELSE 
        WRITE(10,24) ' {',MarkerID(I),wksp1(1:JJ+N+5,I),'},'      
      ENDIF
    ELSE  
      IF(NPairSimu<1)THEN
        WRITE(10,25) ' {',MarkerID(I),wksp1(1:JJ+N+5,I),'},'   
      ELSE 
        WRITE(10,21) ' {',MarkerID(I),wksp1(1:JJ+N+5,I),'},'      
      ENDIF
    ENDIF
  ENDDO
21 FORMAT(A,A,10ES12.4,A)
22 FORMAT(A,A,12ES12.4,A)
23 FORMAT(A,A,9ES12.4,A)
24 FORMAT(A,A,11ES12.4,A) 
25 FORMAT(A,A,8ES12.4,A)  
  SD=0._DP   
  NT=0
  DO I=1,NumLoci
    SD(1,1)=SD(1,1)+KinshipInfor(I)
    SD(1,2)=SD(1,2)+KinshipInfor(I)**2
    DO J=1,N
      IF(RMSD(J,I)<0._DP)CYCLE
      SD(1+J,1)=SD(1+J,1)+RMSD(J,I)
      SD(1+J,2)=SD(1+J,2)+RMSD(J,I)**2
      NT(1+J)=NT(1+J)+1
    ENDDO    
    DO J=N+2,JJ+N+5
      IF(wksp1(J,I)<0._DP)CYCLE
      SD(J,1)=SD(J,1)+wksp1(J,I)
      SD(J,2)=SD(J,2)+wksp1(J,I)**2 
      NT(J)=NT(J)+1     
    ENDDO
  ENDDO
  NT(1)=NumLoci
  DO I=1,JJ+N+5
    J=NT(I)
    IF(J>1)THEN
      SD(i,1)=SD(I,1)/J
      SD(I,2)=SQRT(ABS(SD(I,2)/J-SD(I,1)**2))
    ELSEIF(J>0)THEN
      SD(I,2)=0._DP
    ELSE
      SD(I,:)=-1
    ENDIF
  ENDDO  
  WRITE(10,'(/A,13ES12.4)')'      Mean  ',SD(1:JJ+N+5,1)
  WRITE(10,'(A,13ES12.4)') '        SD  ',SD(1:JJ+N+5,2)
  WRITE(10,'(99(/A))')'NOTE 1: RMSD=-1 denotes UNDEFINED or UNCALCULATED', &
    'NOTE 2: Mean and SD calculated using loci with determinable values', &
    'NOTE 3: R_Infor denotes Informativeness for Relationship (IR)', &
    '        RMSD(LL) denotes RMSD from Lynch&Li relatedness estimator', &
    '        RMSD(QG) denotes RMSD from Queller&Goodnight relatedness estimator', &
    '        RMSD(R)  denotes RMSD from Ritland relatedness estimator', &
    '        RMSD(LR) denotes RMSD from Lynch&Ritland relatedness estimator', &
    '        RMSD(W)  denotes RMSD from Wang relatedness estimator', &
    '        Threshould & Power (PWR) are from the analytical approach', &
    '        SimuThrshld & SimuPower (PWR) are from the simulation approach', &
    '        r_Infor denotes Informativeness for relatedness (Ir)', &
    '        ExclProb denotes parentage exclusion probability'
  WRITE(10,'(//A/A/A)')LINE, &
    '  Rank order of markers in terms of information content',LINE
  WRITE(10,'(A)')TRIM(TemChar2)
  DO J=1,N+1
    IF(ABS(MAXVAL(wksp1(J,1:))-MINVAL(wksp1(J,1:)))<SMALL)THEN
      INX(J,:)=-1
    ELSE
      CALL INDEXX(NumLoci,wksp1(J,:),INX(J,:))         
    ENDIF 
    DO II=1,NumLoci    
      IF(wksp1(J,II)<0._DP)INX(J,II)=-1
    ENDDO
  ENDDO 
  CALL INDEXX(NumLoci,wksp1(N+3,:),INX(N+2,:))  
  DO II=1,NumLoci    
    IF(wksp1(N+3,II)<0._DP)INX(N+2,II)=-1
  ENDDO  
  IF(NPairSimu>0)THEN
    CALL INDEXX(NumLoci,wksp1(N+5,:),INX(N+3,:))  
    DO II=1,NumLoci    
      IF(wksp1(N+5,II)<0._DP)INX(N+3,II)=-1
    ENDDO    
    I=1
  ELSE
    I=0
  ENDIF
  CALL INDEXX(NumLoci,wksp1(JJ+N+4,:),INX(N+I+3,:))
  DO II=1,NumLoci    
    IF(wksp1(JJ+N+4,II)<0._DP)INX(N+I+3,II)=-1
  ENDDO    
  IF(Maxval(wksp1(JJ+N+5,:))>Small)THEN
    CALL INDEXX(NumLoci,wksp1(JJ+N+5,:),INX(N+I+4,:))  
    DO II=1,NumLoci    
      IF(wksp1(JJ+N+5,II)<0._DP)INX(N+I+4,II)=-1
    ENDDO      
  ELSE
    INX(N+I+4,:)=-1
  ENDIF
  INX(12,:)=0
  DO I=1,NumLoci
    IF(NPairSimu<1)THEN
      J=N+4
    ELSE
      J=N+5
    ENDIF
    DO L=1,J
      DO K=1,NumLoci
        IF(INX(L,K)==I) INX(12,L)=NumLoci+1-K
      ENDDO
    ENDDO
    WRITE(10,'(A,A,12I12)') '  ',MarkerID(I),INX(12,1:J)
  ENDDO    
  WRITE(10,'(/A/)')'NOTE: 0 indicates that rank order undetermined for a locus'
  DO I=1,JJ+N+4
    DO J=I+1,JJ+N+5
      II=0
      DO J1=1,NumLoci
        IF(wksp1(I,J1)>=0._DP.AND.wksp1(J,J1)>=0._DP)THEN
          II=II+1
          wksp4(II)=wksp1(I,J1)
          wksp5(II)=wksp1(J,J1)
        ENDIF
      ENDDO
      IF(II<2)THEN
        spear_r(I,J)=0
      ELSE
        CALL spear(wksp4(1:II),wksp5(1:II),II,wksp2(1:II),wksp3(1:II),tem(1), &
          tem(2),tem(3),spear_r(I,J),tem(4))
      ENDIF
    ENDDO  
  ENDDO
  WRITE(10,'(/A/A)')LINE,'Spearman rank-order correlation coefficient',LINE
  temchar1='            '//temchar1(25:Len_Trim(temchar1))
  WRITE(10,'(a)')temchar1
  DO I=1,263
    temchar2(I:I)=' '
  ENDDO
  DO I=1,JJ+N+4
    IF(I==1)THEN
      WRITE(10,'(A,99F12.4)')'     R_Infor',spear_r(I,I+1:JJ+N+5)
    ELSE
      WRITE(10,'(A,99F12.4)')temchar1((I-1)*12+1:I*12)// &
        temchar2(1:(I-1)*12),spear_r(I,I+1:JJ+N+5)
    ENDIF 
  ENDDO    
  IF(NumLoci>1)THEN  
    WRITE(10,'(//A/A/A/)')LINE, &
      '  Multilocus measurements of information content',LINE  
    WRITE(10,'(/A,ES18.6)') &
      'MultiLocus Threshould (Analytical) for likelihood ratio test:  ', &
      Threshould(0)   
    WRITE(10,'(/A,ES18.6)') &
      'MultiLocus Power (Analytical) for likelihood ratio test:       ', &
      Power(0)  
    IF(NPairSimu>0)THEN
      WRITE(10,'(/A,ES18.6)') &
      'MultiLocus Threshould (simulation) for likelihood ratio test:  ', &
        ThreshouldSimu(0)   
      WRITE(10,'(/A,ES18.6)') &
      'MultiLocus Power (simulation) for likelihood ratio test:       ', &
        PowerSimu(0)  
    ENDIF  
    WRITE(10,'(/A,ES18.6)') &
      'MultiLocus parentage exclusion probability (No typing errors): ',&
      ExclProb(0)  
    DO J=1,N
      IF(MAXVAL(RMSD(J,1:NumLoci))<0._DP)THEN
        CYCLE
      ELSE
        RMSD(J,0)=0._DP
        DO L=1,NumLoci
          IF(RMSD(J,L)>0._DP)RMSD(J,0)=RMSD(J,0)+RMSD(J,L)
        ENDDO
      ENDIF     
      IF(J==1)then
        WRITE(10,'(/A,ES18.6)') 'MultiLocus RMSD (LL estimator): ',RMSD(J,0)
      ELSEIF(J==2)then
        WRITE(10,'(/A,ES18.6)')'MultiLocus RMSD (QG estimator): ',RMSD(J,0)
      ELSEIF(J==3)then
        WRITE(10,'(/A,ES18.6)')'MultiLocus RMSD (R estimator):  ',RMSD(J,0)
      ELSEIF(J==4)THEN
        WRITE(10,'(/A,ES18.6)')'MultiLocus RMSD (LR estimator): ',RMSD(J,0)
      ELSE
        WRITE(10,'(/A,ES18.6)')'MultiLocus RMSD (W estimator):  ',RMSD(J,0)  
      ENDIF 
    ENDDO
    WRITE(10,'(/A,A)')'NOTE: MultiLocus RMSD is calculated using loci for which', &
      ' single locus RMSD is calculable'     
  ENDIF  
  CLOSE(10)
  WRITE(*,'(/A/A,A)')'Program completed successfully!', &
    'Analysis results are in file ',OutFileName
  GOTO 7
1 WRITE(*,'(/A)')'Input file "KININFOR.DAT" does not exist!', &
    '  Please create a file with name "KININFOR.DAT" and input your data',&
    '  into it. Please check the data format and input file name and then',&
    '  re-run the program'
  GOTO 7
9 WRITE(*,'(/A)')'Errors in DATA. Insufficient/incorrect data or format.',&
    '  Please check DATA and format and then re-run the program'
7 WRITE(*,'(///A)') &
    'Press any number/letter key and "enter" key to STOP the program'
  READ(*,*)OutFileName
  STOP  
END PROGRAM MAIN
!
Subroutine DelayedExit(T)
  IMPLICIT NONE
  REAL, INTENT(IN) :: T
  REAL :: DelayTime(2)
  Call CPU_TIME(DelayTime(1))
  DO
    Call CPU_TIME(DelayTime(2))
    IF(DelayTime(2) - DelayTime(1) > T) EXIT
  END DO
  STOP
END Subroutine DelayedExit
!
SUBROUTINE PHENOTYPE(A,B,C,D,K,E,P)    
USE VARIABLES
INTEGER::A,B,C,D,K,IAllele(4),I,J,MARK
REAL(DP):: P(K),E,E2,Q(4),F(4),X,Y
E2=E/K
IF(Ploidy2==4)THEN  !Diploid-Diploid dyad
  IAllele=(/A,B,C,D/)
  MARK=0
  DO I=1,4
    DO J=I+1,4
      IF(IAllele(I)==IAllele(J))MARK=MARK+1
    ENDDO
  ENDDO
  IF(MARK==6)THEN 
    F(1)=P(A)*(1._DP-E)+E2
    X=(1._DP-P(A))*P(A)*(1-E)**2
    Y=X*F(1)*F(1)
    TAO(0:2)=(/F(1)**4,Y,Y+Y+X*X/) 
  ELSEIF(MARK==3)THEN
    IF(A==B)THEN  
      Q(1)=P(A)
      IF(C==A)THEN
        Q(2)=P(D)
      ELSE
        Q(2)=P(C)    
      ENDIF
    ELSE        
      Q(1)=P(C)
      IF(C==A)THEN
        Q(2)=P(B)
      ELSE
        Q(2)=P(A)    
      ENDIF  
    ENDIF  
    F(1:2)=Q(1:2)*(1._DP-E)+E2 
    X=Q(1)*(1-E)**2
    Y=X*(F(2)-Q(1)*F(2)-Q(2)*F(1))*F(1)
    TAO(0:2)=(/2*F(1)**3*F(2),Y,2*(Y-X*X*(1-Q(1))*Q(2))/)
  ELSEIF(A==B.OR.C==D)THEN 
    IF(A==B)THEN
      Q(1:3)=(/P(A),P(C),P(D)/)
    ELSE
      Q(1:3)=(/P(C),P(A),P(B)/)  
    ENDIF                   
    I=MARK-1  
    F(1:3)=Q(1:3)*(1._DP-E)+E2  
    X=-Q(1)*(1-E)**2
    Y=X*(Q(2)*F(3)+Q(3)*F(2))*F(1)/(1+I)
    TAO(0:2)=(/(2-I)*F(1)**2*F(2)*F(3),Y,2*(Y+X*X*Q(2)*Q(3)/(1+I))/)    
  ELSEIF(MARK==2.AND.A/=B.AND.C/=D)THEN  
    Q(1:2)=(/P(A),P(B)/)
    F(1:2)=Q(1:2)*(1._DP-E)+E2 
    X=Q(1)*Q(2)*(1-E)**2
    Y=(E2*(E2*(Q(1)+Q(2))+4*Q(1)*Q(2)*(1-E))*(1-Q(1)-Q(2))+ &
      X*(Q(1)+Q(2)-4*Q(1)*Q(2)))*(1-E)**2
    TAO(0:2)=(/4*(F(1)*F(2))**2,Y,2*(Y+X*(1-E)**2*(1-Q(1)- &
      Q(2)+2*Q(1)*Q(2)))/)
  ELSEIF(MARK==0)THEN
    Q(1:4)=(/P(A),P(B),P(C),P(D)/)
    F(1:4)=Q(1:4)*(1._DP-E)+E2   
    X=(1-E)**2
    Y=-(Q(1)*F(2)+Q(2)*F(1))*(Q(4)*F(3)+Q(3)*F(4))*X
    TAO(0:2)=(/4*PRODUCT(F(1:4)),Y,2*(Y+2*PRODUCT(Q(1:4))*X*X)/)
  ELSE  
    IF(A==C)THEN
      Q(1:3)=(/P(A),P(B),P(D)/)  
    ELSEIF(A==D)THEN
      Q(1:3)=(/P(A),P(B),P(C)/)      
    ELSEIF(B==C)THEN  
      Q(1:3)=(/P(B),P(A),P(D)/)  
    ELSE
      Q(1:3)=(/P(B),P(A),P(C)/)  
    ENDIF
    F(1:3)=Q(1:3)*(1._DP-E)+E2  
    X=(1-E)**2
    Y=-(E2*E2*((Q(1)+Q(2))*(Q(1)+Q(3))-Q(1))-E2*Q(1)*((1-Q(1)-Q(1))* &
      (Q(2)+Q(3))-4*Q(2)*Q(3))*(1-E)-Q(1)*(1-4*Q(1))*Q(2)*Q(3)*X)*X
    TAO(0:2)=(/4*F(1)**2*F(2)*F(3),Y,2*(Y-Q(1)*(1-Q(1)-Q(1))*Q(2)*Q(3)*X*X)/)
  ENDIF
ELSEIF(Ploidy2==3)THEN !Diploid-haploid dyad
  IF(A==B)THEN     !Diploid is homozygote 
    F(1)=P(A)*(1._DP-E)+E2  
    IF(A==C)THEN 
      TAO(0:1)=(/F(1)**3,P(A)*(1-P(A))*F(1)*(1-E)**2/)
    ELSE 
      TAO(0:1)=(/F(1)**2*(P(C)*(1._DP-E)+E2),-P(A)*P(C)*F(1)*(1-E)**2/)
    ENDIF
  ELSEIF(C/=A.AND.C/=B)THEN    
    F(1)=P(A)*(1._DP-E)+E2
    F(2)=P(B)*(1._DP-E)+E2  
    F(3)=P(C)*(1._DP-E)+E2  
    TAO(0:1)=(/2*F(1)*F(2)*F(3),-P(C)*(P(A)*F(2)+P(B)*F(1))*(1-E)**2/)
  ELSE   
    IF(C==A)THEN
      Q(1:2)=(/P(A),P(B)/)
    ELSE
      Q(1:2)=(/P(B),P(A)/)
    ENDIF
    F(1:2)=Q(1:2)*(1._DP-E)+E2    
    TAO(0:1)=(/2*F(1)*F(1)*F(2),-Q(1)*(Q(1)*F(2)+Q(2)*F(1)-F(2))*(1-E)**2/)
  ENDIF
ELSE               !Haploid-haploid dyad                                        
  IF(A/=B)THEN
    TAO(0:1)=(/(P(A)*(1._DP-E)+E2)*(P(B)*(1._DP-E)+E2),-P(A)*P(B)*(1-E)**2/)
  ELSE
    TAO(0:1)=(/(P(A)*(1._DP-E)+E2)**2,-P(A)*(1-E)**2*(P(A)-1)/)
  ENDIF
ENDIF
END SUBROUTINE PHENOTYPE                 
                            
SUBROUTINE RelationshipInfor(K,E,P,RInfor,Markertype2)     
USE VARIABLES
INTEGER::K,J1,J2,J3,J4,Markertype2
REAL(DP):: P(K),E,X(2),Y,Prob,RInfor,DiploidInfor,TAO2(0:2)
EXTERNAL:: DiploidInfor,PHENOTYPE
RInfor=0._DP  
IF(Ploidy2==4)THEN        !Diploid-Diploid DYAD  
  IF(Markertype2==1)THEN  !Codominant markers
    DO j1=1,K         
      DO j2=j1,K
        DO j3=J1+1,K         
          DO j4=j3,K                    
            RInfor=RInfor-2._DP*DiploidInfor(J1,j2,j3,j4,K,E,P)
          ENDDO
        ENDDO              
        DO J4=J2+1,K                 
          RInfor=RInfor-2._DP*DiploidInfor(J1,j2,j1,j4,K,E,P)
        ENDDO
        RInfor=RInfor-DiploidInfor(J1,j2,j1,j2,K,E,P)       
      ENDDO
    ENDDO
  ELSE                  !Dominant markers 
    DO J1=1,3
      IF(J1==1)THEN     !Recessive:Recessive
        CALL PHENOTYPE(1,1,1,1,2,E,P) 
        TAO2(0:2)=TAO(0:2)
      ELSEIF(J1==2)THEN !Recessive:Dominant
        CALL PHENOTYPE(1,1,1,2,2,E,P) 
        TAO2(0:2)=TAO(0:2)
        CALL PHENOTYPE(1,1,2,2,2,E,P) 
        DO J2=0,2
          TAO2(J2)=2*(TAO2(J2)+TAO(J2))
        ENDDO
      ELSE              !Dominant:Dominant
        CALL PHENOTYPE(1,2,1,2,2,E,P) 
        TAO2(0:2)=TAO(0:2)     
        CALL PHENOTYPE(1,2,2,2,2,E,P) 
        DO J2=0,2
          TAO2(J2)=TAO2(J2)+TAO(J2)*2
        ENDDO         
        CALL PHENOTYPE(2,2,2,2,2,E,P) 
        DO J2=0,2
          TAO2(J2)=TAO2(J2)+TAO(J2)
        ENDDO        
      ENDIF
      X=0._DP  
      DO L=1,NumberR
        Prob=TAO2(0)+TAO2(1)*PHI(L)+TAO2(2)*DELTA(L)           
        X(1)=X(1)+Prob
        IF(Prob>Small)X(2)=X(2)+Prob*Log(Prob)
      ENDDO
      X=X/NumberR
      IF(X(1)>Small)X(1)=X(1)*LOG(X(1))
      RInfor=RInfor-(X(1)-X(2))
    ENDDO   
  ENDIF
ELSE                    !Diploid-haploid OR Haploid-haploid DYAD
  IF(Ploidy2==3.AND.Markertype2/=1)THEN  !Dominant markers
    DO J3=1,2
      DO J1=1,2
        DO J2=J1,2
          X=0._DP
          CALL PHENOTYPE(j1,j2,j3,j4,K,E,P)
          IF(J1/=2)THEN
            TAO2(0:1)=TAO(0:1)
            IF(J2==2)CYCLE
          ELSE
            DO L=0,1
              TAO2(L)=TAO2(L)+TAO(L)
            ENDDO
          ENDIF
          DO L=1,NumberR   
            Prob=TAO2(0)+TAO2(1)*PHI(L)      
            X(1)=X(1)+Prob
            IF(Prob>Small)X(2)=X(2)+Prob*Log(Prob)
          ENDDO
          X=X/NumberR
          IF(X(1)>Small)X(1)=X(1)*LOG(X(1))
          RInfor=RInfor-(X(1)-X(2))   
        ENDDO
      ENDDO
    ENDDO             
  ELSE
    DO j1=1,K         
      DO j2=j1,K
        DO j3=1,K
          X=0._DP            
          CALL PHENOTYPE(j1,j2,j3,j4,K,E,P)
          DO L=1,NumberR
            IF(Ploidy2==3)THEN
              Prob=TAO(0)+TAO(1)*PHI(L)
            ELSE
              Prob=TAO(0)+TAO(1)*DELTA(L)
            ENDIF
            X(1)=X(1)+Prob
            IF(Prob>Small)X(2)=X(2)+Prob*Log(Prob)
          ENDDO
          X=X/NumberR
          IF(X(1)>Small)X(1)=X(1)*LOG(X(1))
          Y=X(1)-X(2)
          RInfor=RInfor-Y   
          IF(Ploidy2<3)THEN
            IF(J1/=J2)RInfor=RInfor-Y
            EXIT
          ENDIF
        ENDDO
      ENDDO
    ENDDO
  ENDIF
ENDIF       
END SUBROUTINE RelationshipInfor              

FUNCTION DiploidInfor(J1,j2,j3,j4,K,E,P)
USE VARIABLES
REAL(DP):: DiploidInfor,Prob,X(2),P(K),E
INTEGER:: L,J1,j2,j3,j4,K
EXTERNAL:: PHENOTYPE
  X=0._DP  
  CALL PHENOTYPE(j1,j2,j3,j4,K,E,P)  
  DO L=1,NumberR
    Prob=TAO(0)+TAO(1)*PHI(L)+TAO(2)*DELTA(L)    
    X(1)=X(1)+Prob
    IF(Prob>Small)X(2)=X(2)+Prob*Log(Prob)      
  ENDDO
  X=X/NumberR
  IF(X(1)>Small)X(1)=X(1)*LOG(X(1))
  DiploidInfor=X(1)-X(2)
END FUNCTION DiploidInfor 
                           
SUBROUTINE RMSDsub(K,E,P,RMSD,Markertype2)     
USE VARIABLES
INTEGER:: K,I,J,J1,J2,J3,J4,J5,L1,L2,IAB,ICD,IAC,IAD,IBC,IBD, &
  Undefine(5),Markertype2,GTYPE(2,2)
REAL(DP):: P(K),E,X,RMSD(5),EST(5),A(4),S0,Y(2),FUNC2,FUNC1, &
  T0,T1,T2,T3,TAO2(0:2),WANG
FUNC2(T0,T1,T2,T3)=T0*T3**2+((BETA(1)+BETA(1)**2-4*BETA(2)*BETA(0))*T0 &
           +3*BETA(2)*(1+BETA(2))*T2+BETA(1)*BETA(2)*(4*T1+T2) &
           -4*(BETA(2)*T2+(1+BETA(1)+2*BETA(2))*(BETA(1)*T1+       &
           BETA(2)*T2))*T3)/(4*BETA(3)*(BETA(3)+1))+(BETA(1)*T1 &
           *(2+3*BETA(1)+BETA(1)**2)+BETA(2)*T2*(BETA(2)+1)*(2+BETA(2)- &
           3*BETA(0))-BETA(0)*BETA(1)*BETA(2)*(4*T1+T2))/(4*BETA(3)&
           *(BETA(3)+1)*(BETA(3)+2))+(BETA(2)*T0-(BETA(1)+2*BETA(2))*   &
           T0*T3+(BETA(1)*T1+BETA(2)*T2)*T3**2)/BETA(3)
FUNC1(T0,T1,T3,J)=BETA(J)/BETA(3)*(BETA(J)+1)/(BETA(3)+1)* &
           (BETA(J)+2)/(BETA(3)+2)*T1+BETA(J)/BETA(3)*   &
           (BETA(J)+1)/(BETA(3)+1)*T0-(2._DP*BETA(J)/    &
           BETA(3)*(BETA(J)+1)/(BETA(3)+1)*T1+2._DP*BETA(J)/ &
           BETA(3)*T0)*T3+(BETA(J)/BETA(3)*T1+T0)*T3**2            
EXTERNAL:: PHENOTYPE
DO I=2,4
  A(I)=P(1)**I
  DO J=2,K
    A(I)=A(I)+P(J)**I
  ENDDO
ENDDO
RMSD=0._DP
IF(Ploidy2==4.AND.Markertype2==1)THEN    !Diploid-Diploid DYAD, Codominant marker
  Undefine=0
  IF(k==2)THEN 
    Undefine(2)=1                        !QG Estimator undefined for biallelic locus
    IF(ABS(P(1)-P(2))<TINY)Undefine(4)=1 !LL estimator undefined
  ENDIF    
  S0=A(2)+A(2)-A(3)
  DO J1=1,K  
    GTYPE(1,1)=J1       
    DO J2=j1,K
      GTYPE(2,1)=J2
      IF(J1==J2)THEN
        IAB=1
      ELSE  
        IAB=0            
      ENDIF    
      DO J3=1,K
        GTYPE(1,2)=J3
        DO J4=J3,K     
          GTYPE(2,2)=J4
          CALL PHENOTYPE(j1,j2,j3,j4,K,E,P)                 
          IF(J3==J4)THEN
            ICD=1
          ELSE  
            ICD=0 
          ENDIF        
          IF(J1==J3)THEN
            IAC=1
          ELSE
            IAC=0
          ENDIF
          IF(J1==J4)THEN
            IAD=1
          ELSE
            IAD=0
          ENDIF
          IF(J2==J3)THEN
            IBC=1
          ELSE
            IBC=0
          ENDIF          
          IF(J2==J4)THEN
            IBD=1
          ELSE
            IBD=0
          ENDIF
          I=IAC+IAD+IBC+IBD         
          IF(I==4.OR.(I==2.AND.J1/=J2.AND.J3/=J4))THEN
            EST(1)=1
          ELSEIF(I==2)THEN
            EST(1)=(.75_DP-S0)/(1-S0)
          ELSEIF(I==1)THEN
            EST(1)=(.5_DP-S0)/(1-S0)  
          ELSE       
            EST(1)=-S0/(1-S0)
          ENDIF
          IF(Undefine(2)==0)THEN 
            Y=(/1+IAB-P(J1)-P(J2),1+ICD-P(J3)-P(J4)/)          
            EST(2)=(I*.5_DP-P(J1)-P(J2))/(2*Y(1))+(I*.5_DP-P(J3)-P(J4))/(2*Y(2))
          ENDIF
          EST(3)=0._DP
          DO J5=1,K
            IF(J5/=J1.AND.J5/=J2)THEN
              CYCLE
            ELSEIF(J1==J2)THEN
              L1=2
            ELSE
              L1=1
            ENDIF
            IF(J5/=J3.AND.J5/=J4)THEN
              CYCLE
            ELSEIF(J3==J4)THEN
              L2=2
            ELSE
              L2=1
            ENDIF
            EST(3)=EST(3)+L1*L2/P(J5)
          ENDDO
          EST(3)=(EST(3)/4-1)*2._DP/(K-1)    
          IF(Undefine(4)==0)THEN
            Y(1)=(1+IAB)*(P(J1)+P(J2))-4*P(J1)*P(J2)
            Y(2)=(1+ICD)*(P(J3)+P(J4))-4*P(J3)*P(J4)                  
            EST(4)=(P(J1)*(IBC+IBD)+P(J2)*(IAC+IAD)-4*P(J1)*P(J2))/(2*Y(1))+ & 
                   (P(J3)*(IAD+IBD)+P(J4)*(IAC+IBC)-4*P(J3)*P(J4))/(2*Y(2))
          ENDIF          
          EST(5)=WANG(GTYPE,k,A(2:4))                   
          DO J=1,5 
            IF(Undefine(J)==0) RMSD(J)=RMSD(J)+FUNC2(TAO(0),TAO(1),TAO(2),EST(J))
          ENDDO                 
        ENDDO
      ENDDO
    ENDDO
  ENDDO 
  DO j=1,5
    IF(Undefine(J)==0)THEN  
      RMSD(J)=1._DP/RMSD(J)
    ELSE
      RMSD(J)=-1
    ENDIF
  ENDDO
ELSEIF(Ploidy2==4)THEN    !Diploid-Diploid DYAD, Dominant marker 
  DO J=1,3
    IF(J==1)THEN
      CALL PHENOTYPE(1,1,1,1,2,E,P) 
      TAO2(0:2)=TAO(0:2)
      EST(1)=1      
    ELSEIF(J==2)THEN
      CALL PHENOTYPE(1,1,1,2,2,E,P) 
      TAO2(0:2)=TAO(0:2)  
      CALL PHENOTYPE(1,1,2,2,2,E,P) 
      DO J1=0,2
        TAO2(J1)=2*(TAO2(J1)+TAO(J1))
      ENDDO
      X=P(1)*P(1)
      X=1-2*X*(1-X)      
      EST(1)=-X/(1-X)
    ELSE
      CALL PHENOTYPE(1,2,1,2,2,E,P) 
      TAO2(0:2)=TAO(0:2)    
      CALL PHENOTYPE(1,2,2,2,2,E,P) 
      DO J1=0,2
        TAO2(J1)=TAO2(J1)+TAO(J1)*2
      ENDDO     
      CALL PHENOTYPE(2,2,2,2,2,E,P) 
      DO J1=0,2
        TAO2(J1)=TAO2(J1)+TAO(J1)
      ENDDO        
      EST(1)=1
    ENDIF
    RMSD(1)=RMSD(1)+FUNC2(TAO2(0),TAO2(1),TAO2(2),EST(1))   
  ENDDO
  RMSD(1)=1._DP/RMSD(1)
ELSEIF(Ploidy2==2.OR.Markertype2==1)THEN !Diploid-haploid OR Haploid-haploid DYAD 
  IF(Ploidy2==3)THEN
    J4=K
  ELSE
    J4=1
  ENDIF
  DO J1=1,K         
    DO J2=j1,K          
      DO J3=1,J4       
        CALL PHENOTYPE(j1,j2,j3,j1,K,E,P)
        IF(Ploidy2==2)THEN
          IF(J1==J2)THEN   
            EST(1:2)=1
            EST(3)=(1-P(J1))/(P(J1)*(K-1))
          ELSE
            EST(1)=-A(2)/(1-A(2))
            EST(2)=-(P(J1)/(1-P(J1))+P(J2)/(1-P(J2)))*0.5_DP      
            EST(3)=-P(J1)/(P(J1)*(K-1))        
          ENDIF
        ELSE 
          IF(J3==J1.AND.J3==J2)THEN
            EST(1)=1._DP
            IF(K>2)THEN
              EST(2)=0.75_DP
            ELSE
              EST(2)=1._DP
            ENDIF
            EST(3)=(1-P(J3))/(P(J3)*(K-1))
            IF(K==2.AND.ABS(P(1)-P(2))<Tiny)THEN
              EST(4)=1._DP
            ELSE
              EST(4)=0.75_DP
            ENDIF
          ELSEIF(J3/=J1.AND.J3/=J2)THEN
            EST(1)=-A(2)/(1-A(2))
            IF(K>2)THEN  
              IF(J1==J2)THEN
                EST(2)=-P(J1)/(1-P(J1))/4-P(J3)/(1-P(J3))/2
              ELSE 
                EST(2)=-(P(J1)+P(J2))/(1-P(J1)-P(J2))/4-P(J3)/(1-P(J3))/2
              ENDIF             
            ELSE               
              EST(2)=-P(J3)/(1-P(J3))           
            ENDIF 
            EST(3)=-1._DP/(K-1)   
            IF(K==2.AND.ABS(P(1)-P(2))<Tiny)THEN
              EST(4)=-1._DP
            ELSE                                 
              IF(J1==J2)THEN
                EST(4)=-P(J1)/(1-P(J1))/4-P(J3)/(1-P(J3))/2
              ELSE 
                EST(4)=-P(J1)*P(J2)/(P(J1)+P(J2)-4*P(J1)*P(J2))-P(J3)/(1-P(J3))/2
              ENDIF
            ENDIF
          ELSE
            EST(1)=(0.5_DP-A(2))/(1-A(2))
            IF(K>2)THEN            
              EST(2)=.25_DP+(1-2*P(J3))/(1-P(J3))/4
            ELSE  
              EST(2)=(1-2*P(J3))/(1-P(J3))/2
            ENDIF
            EST(3)=(1-2*P(J3))/(2*(K-1)*P(J3))
            IF(K==2.AND.ABS(P(1)-P(2))<Tiny)THEN 
              EST(4)=0._DP
            ELSE
              IF(J3==J1)THEN
                EST(4)=P(J2)*(1-2*P(J1))/(P(J1)+P(J2)-4*P(J1)*P(J2))/2+ &
                  (1-2*P(J3))/(1-P(J3))/4
              ELSE
                EST(4)=P(J1)*(1-2*P(J2))/(P(J1)+P(J2)-4*P(J1)*P(J2))/2+ &
                  (1-2*P(J3))/(1-P(J3))/4            
              ENDIF
            ENDIF
          ENDIF
        ENDIF        
        if(Ploidy2==3)est(1:4)=est(1:4)*2          
        DO J=1,1+Ploidy2
          X=FUNC1(TAO(0),TAO(1),EST(J),4-Ploidy2)          
          RMSD(J)=RMSD(J)+X            
          IF(Ploidy2==2.AND.J1/=J2) RMSD(J)=RMSD(J)+X
        ENDDO            
      ENDDO
    ENDDO
  ENDDO   
  IF(Ploidy2==3)THEN
    FORALL(J=1:4)RMSD(j)=0.25_DP/RMSD(J)
  ELSE 
    FORALL(J=1:3)RMSD(j)=1._DP/RMSD(J)    
  ENDIF
ELSE    !Diploid-haploid dyad & Dominant marker
  DO J3=1,2
    DO J1=1,2
      DO J2=J1,2
        CALL PHENOTYPE(j1,j2,j3,j4,K,E,P)
        IF(J1==1)THEN
          TAO2(0:1)=TAO(0:1)
          IF(J2==2)CYCLE
        ELSE
          DO J=0,1
            TAO2(J)=TAO2(J)+TAO(J)
          ENDDO
        ENDIF
        IF(J3==1)THEN
          IF(J1==1.AND.J2==1)THEN
            X=1
          ELSE
            X=0
          ENDIF
        ELSE
          IF(J1==1.AND.J2==1)THEN
            X=0
          ELSE
            X=1
          ENDIF
        ENDIF
        EST(1)=2*(.25_DP+(X-1+P(1)-P(1)**3)/(4*(1-P(1))*P(1)**2)) !Est of PHI
        RMSD(1)=RMSD(1)+FUNC1(TAO2(0),TAO2(1),EST(1),1)
      ENDDO
    ENDDO             
  ENDDO
  RMSD(1)=.25_DP/RMSD(1)
ENDIF          
IF(Ploidy2>2.and.Markertype2/=1)RMSD(2:4)=-1._DP
IF(Markertype2/=1.OR.Ploidy2/=4)RMSD(5)=-1._DP
END SUBROUTINE RMSDsub
!
Function WANG(GTYPE,LALLELE,AA)
 USE VARIABLES
 INTEGER:: GTYPE(2,2),LALLELE
 REAL(DP):: EST2(3),AA(2:4),A(3,2),DIVISION,S(3),WANG
 IF(LALLELE==2)THEN
   A(1,1)=1.E-50_DP
   A(1,2)=A(1,1)
 ELSE
   A(1,1)=4*(AA(2)-AA(2)**2-2*AA(3)+2*AA(4))
   A(1,2)=1-7*AA(2)+4*AA(2)**2+10*AA(3)-8*AA(4)
 ENDIF
 A(2,1)=4*(AA(3)-AA(4))
 A(2,2)=2*(AA(2)-3*AA(3)+2*AA(4))
 A(3,1)=2*AA(2)**2-AA(4)
 A(3,2)=AA(2)-2*AA(2)**2+AA(4)
 DIVISION=(A(1,2)**2*A(2,1)*(-1+A(3,1))*(-1+A(2,1)+A(3,1)) &
   -2*A(1,1)*A(1,2)*A(2,1)*(-1+A(3,1))*(A(2,2)+A(3,2))+A(1,1) &
   *(A(2,2)**2*(-1+A(3,1))*(-1+A(1,1)+A(3,1))-2*A(2,1)*A(2,2) &
   *(-1+A(3,1))*A(3,2)+A(2,1)*(A(1,1)+A(2,1))*A(3,2)**2))
 S(1:3)=0._DP
 IF((GTYPE(1,1)==GTYPE(1,2).AND.GTYPE(2,1)==GTYPE(2,2)) &
   .OR.(GTYPE(1,1)==GTYPE(2,2).AND.GTYPE(2,1)==GTYPE(1,2)))THEN
     S(3)=1
 ELSE
   K=0
   IF(GTYPE(1,1)==GTYPE(1,2))K=K+1
   IF(GTYPE(1,1)==GTYPE(2,2))K=K+1
   IF(GTYPE(2,1)==GTYPE(1,2))K=K+1
   IF(GTYPE(2,1)==GTYPE(2,2))K=K+1
   IF(K==2.OR.K==1) S(K)=1
 ENDIF
 EST2(1)=(A(1,2)*A(2,1)*(-1+A(3,1))*(-1+A(2,1)+A(3,1))*S(1)+A(1,1) &
   **2*(A(2,2)*(-1+A(3,1))*S(2)+A(2,1)*A(3,2)*(-1+S(3)))+A(1,1)*(  &
   -(A(2,1)*A(2,2))+A(2,1)*A(2,2)*A(3,1)-A(2,1)**2*A(3,2)+A(2,1)   &
   *A(2,2)*S(1)-A(2,1)*A(2,2)*A(3,1)*S(1)+A(2,1)*A(3,2)*S(1)-A(2,1)&
   *A(3,1)*A(3,2)*S(1)+A(2,2)*S(2)-2*A(2,2)*A(3,1)*S(2)+A(2,2)     &
   *A(3,1)**2*S(2)+A(2,1)*A(3,2)*S(2)-A(2,1)*A(3,1)*A(3,2)*S(2)    &
   +A(2,1)*A(2,2)*S(3)-A(2,1)*A(2,2)*A(3,1)*S(3)+A(2,1)**2*A(3,2)  &
   *S(3)-A(1,2)*A(2,1)*(-1+A(3,1))*(-1+S(2)+S(3))))/DIVISION
 EST2(2)=(A(1,2)**2*A(2,1)*(-1+A(2,1)+A(3,1))*(A(3,1)-S(3))+A(1,1) &
   *(A(2,1)*A(3,2)**2*(A(1,1)+A(2,1)-S(1)-S(2))+A(2,2)**2*(-1      &
   +A(1,1)+A(3,1))*(A(3,1)-S(3))+A(2,2)*A(3,2)*(A(2,1)-2*A(2,1)    &
   *A(3,1)-A(2,1)*S(1)-S(2)+A(1,1)*S(2)+A(3,1)*S(2)+A(2,1)*S(3)))  &
   +A(1,2)*A(2,1)*((-1+A(2,1)+A(3,1))*A(3,2)*S(1)+A(1,1)*(-2*A(2,2)&
   *A(3,1)+A(3,2)-2*A(3,1)*A(3,2)-A(3,2)*S(2)+2*A(2,2)*S(3)+A(3,2) &
   *S(3))))/DIVISION
 EST2(3)=0.5_DP*EST2(1)+EST2(2)
 WANG=EST2(3)
 END Function WANG
                            
SUBROUTINE PowerSub(NumLoci,NumAllele,MaxNumAllele,P, &
  MinPrec,Threshould,Power,ThreshouldSimu,PowerSimu,MarkerType2,ErrRate)
USE VARIABLES
INTEGER:: NumLoci,MaxNumAllele,NumAllele(NumLoci),MarkerType2(NumLoci)
REAL(DP):: P(MaxNumAllele, NumLoci),Prec2,MinPrec,XLength,X,Y(2,2), &
  Threshould,Power,CP(MaxNumAllele, NumLoci),ThreshouldSimu,PowerSimu, &
  RatioMax,ErrRate(NumLoci)
REAL(DP),ALLOCATABLE:: List0(:,:),List1(:,:),List2(:,:),List3(:,:),List4(:,:)
INTEGER,ALLOCATABLE:: INX0(:),INX1(:),INX2(:)
EXTERNAL:: LikelihoodRatio,INDEXX,SHORTEN,POLINT,SimuGenotype
  MinPrec=Prec1
  IF(Ploidy2==2)THEN
    Length1=NumAllele(1)*(NumAllele(1)+1)/2
  ELSEIF(Ploidy2==3)THEN
    IF(MarkerType2(1)==1)THEN
      Length1=NumAllele(1)**2*(NumAllele(1)+1)/2
    ELSE
      Length1=4
    ENDIF
  ELSE
    IF(MarkerType2(1)==1)THEN  
      Length1=NumAllele(1)*(NumAllele(1)+1)*(2+NumAllele(1)+NumAllele(1)**2)/8
    ELSE
      Length1=3
    ENDIF    
  ENDIF
  ALLOCATE(List1(Length1,3),INX1(Length1))
  CALL LikelihoodRatio(NumAllele(1),ErrRate(1),P(:NumAllele(1), 1), &
    List1,Length1,MarkerType2(1)) 
  CALL INDEXX(Length1,List1(:,1),INX1) 
  IF(NumLoci>1)THEN
    Length0=Length1
    ALLOCATE(List0(Length0,3),INX0(Length0))
    FORALL(J=1:Length0)
      List0(J,1:3)=List1(J,1:3)
      INX0(J)=INX1(J)  
    END FORALL      
  ENDIF
  Power=0
  DO I=1,NumLoci
    IF(I>1)THEN
      IF(MarkerType2(1)==MarkerType2(I).AND.NumAllele(1)==NumAllele(I) &
        .AND.ABS(ErrRate(1)-ErrRate(I))<SMALL) THEN
        J1=1
        DO J2=1,NumAllele(1)
          IF(ABS(P(J2, 1)-P(J2, I))>SMALL)THEN
            J1=0
            EXIT
          ENDIF
        ENDDO
      ELSE
        J1=0
      ENDIF
      IF(J1==1)THEN
        Length2=Length0
        ALLOCATE(List2(Length2,3),INX2(Length2))      
        List2(1:Length0,1:3)=List0(1:Length0,1:3)
        INX2(1:Length0)=INX0(1:Length0)
      ELSE                          
        IF(Ploidy2==2)THEN
          Length2=NumAllele(I)*(NumAllele(I)+1)/2
        ELSEIF(Ploidy2==3)THEN
          IF(MarkerType2(I)==1)THEN    
            Length2=NumAllele(I)**2*(NumAllele(I)+1)/2
          ELSE
            Length2=4
          ENDIF        
        ELSE
          IF(MarkerType2(I)==1)THEN 
            Length2=NumAllele(I)*(NumAllele(I)+1)*(2+NumAllele(I)+NumAllele(I)**2)/8
          ELSE
            Length2=3
          ENDIF      
        ENDIF
        ALLOCATE(List2(Length2,3),INX2(Length2))
        CALL LikelihoodRatio(NumAllele(I),ErrRate(I),P(:NumAllele(I), I), &
          List2,Length2,MarkerType2(I))
        CALL INDEXX(Length2,List2(:,1),INX2)
      ENDIF
      Prec2=Prec1
      XLength=REAL(Length1)*Length2    
      DO   
        IF(XLength>MaxLength)THEN
          IF(Prec2>MinPrec)MinPrec=Prec2  
          IF(.NOT.(ALLOCATED(List3)))ALLOCATE(List3(Length1,3),List4(Length2,3)) 
          CALL SHORTEN(Length1,List1,INX1,Prec2,Length3,List3)        
          CALL SHORTEN(Length2,List2,INX2,Prec2,Length4,List4) 
          XLength=Length3*Length4
          Prec2=Prec2+Prec2
        ELSE                  
          EXIT
        ENDIF
      ENDDO
      Length=NINT(XLength)
      II=0
      IF(ALLOCATED(List3))THEN
        DEALLOCATE(List1,INX1,List2,INX2)
        ALLOCATE(List1(Length,3),INX1(Length))
        DO J1=1,Length3
          DO J2=1,Length4
            II=II+1          
            List1(II,1:3)=List3(J1,1:3)*List4(J2,1:3)
          ENDDO
        ENDDO
        DEALLOCATE(List3,List4)
      ELSE 
        ALLOCATE(List3(Length1,3))
        List3=List1
        DEALLOCATE(List1,INX1)
        ALLOCATE(List1(Length,3),INX1(Length))
        DO J1=1,Length1
          DO J2=1,Length2
            II=II+1           
            List1(II,1:3)=List3(J1,1:3)*List2(J2,1:3)         
          ENDDO
        ENDDO      
        DEALLOCATE(List3,List2,INX2)
      ENDIF      
      Length1=Length
      CALL INDEXX(Length1,List1(:,1),INX1)
    ENDIF
    IF(ALLOCATED(List3))DEALLOCATE(List3)
    ALLOCATE(List3(Length1,3)) 
    CALL SHORTEN(Length1,List1,INX1,Prec1,Length3,List3)                
    X=0._DP
    J=Length3
    DO II=Length3,1,-1
      X=X+List3(II,3)
      IF(X>=Sig_Level)THEN
        Y(1,1:2)=(/X,List3(II,1)/)
        J=II
        EXIT
      ENDIF
    ENDDO
    IF(J<Length3)THEN
      Y(2,1:2)=(/X-List3(J,3),List3(J+1,1)/)
      CALL POLINT(Y(:,1),Y(:,2),2,Sig_Level,Threshould,X)
      IF(Power<0.999999)then
        X=0._DP
        J=0
        DO II=Length3,1,-1
          X=X+List3(II,2)
          IF(List3(II,1)<Threshould)THEN
            Y(1,1:2)=(/List3(II,1),X/)
            J=II
            EXIT
          ENDIF
        ENDDO
        IF(J>0)THEN    
          Y(2,1:2)=(/List3(J+1,1),X-List3(J,2)/)
          CALL POLINT(Y(:,1),Y(:,2),2,Threshould,Power,X)
          IF(Power>1)Power=1._DP      
        ELSE
          Power=1._DP
        ENDIF
      endif
    ELSE 
      Threshould=List3(J,1)
      Power=0
    ENDIF
    DEALLOCATE(List3)    
  ENDDO   
  IF(NumLoci>1)DEALLOCATE(List0,INX0)
  DEALLOCATE(List1)        
!        Simulation procedures to get threashould and power
  IF(NPairSimu>0)THEN  
    DO J=1,NumLoci
      CP(1, J)=P(1, J)
      DO J1=2,NumAllele(J)
        CP(J1, J)=CP(J1-1, J)+P(J1, J)
      ENDDO
      CP(NumAllele(J), J) = 1.1_DP  
    ENDDO             
    CALL SimuGenotype(2,P,CP,NumLoci,NumAllele, &
      MaxNumAllele,RatioMax,ThreshouldSimu,PowerSimu,MarkerType2,ErrRate)     
    IF(ThreshouldSimu<RatioMax)THEN
      CALL SimuGenotype(1,P,CP,NumLoci,NumAllele, &
        MaxNumAllele,RatioMax,ThreshouldSimu,PowerSimu,MarkerType2,ErrRate)
    ELSE 
      PowerSimu=0
    ENDIF
  ELSE
    ThreshouldSimu=-1
    PowerSimu=-1
  ENDIF
END SUBROUTINE PowerSub
!                    
SUBROUTINE SimuGenotype(NSimu,P,CP,NumLoci,NumAllele, &
  MaxNumAllele,RatioMax,ThreshouldSimu,PowerSimu,MarkerType2,ErrRate2)
USE VARIABLES
IMPLICIT NONE
INTEGER, INTENT(IN) :: NSimu,NumLoci,MaxNumAllele
INTEGER:: Length2,NumAllele(NumLoci),IG(4),MarkerType2(NumLoci)
REAL(DP):: Prob(2),PIBD(0:2), P(MaxNumAllele, NumLoci), &
  CP(MaxNumAllele, NumLoci),ThreshouldSimu, &
  PowerSimu,X,Y(2,2),RatioMax,TAO2(0:2),ErrRate2(1:NumLoci)
REAL(DP), Allocatable:: List1(:),List2(:,:)
INTEGER, Allocatable:: INX1(:)
INTEGER :: I, J, J1, J2, irbit
REAL:: RN, RAN1
EXTERNAL:: PHENOTYPE,INDEXX,SHORTENSimu,POLINT, irbit, RAN1
  Allocate(List1(NPairSimu), List2(NPairSimu,2), INX1(NPairSimu))
  IF(Ploidy2==4)THEN
    PIBD(0:2)=(/1._DP-PHI(NSimu)-DELTA(NSimu),1._DP-DELTA(NSimu),1._DP/)
  ELSEIF(Ploidy2==3)THEN
    PIBD(0:1)=(/1._DP-PHI(NSimu),1._DP/)
  ELSE
    PIBD(0:1)=(/1._DP-DELTA(NSimu),1._DP/)
  ENDIF
  DO I=1,NPairSimu         
    List1(I)=1._DP
    DO J=1,NumLoci
      DO J2=1,2
        RN = RAN1()
        DO J1=1,NumAllele(J)
          IF(RN<=CP(J1, J))THEN
            IG(J2)=J1
            EXIT
          ENDIF
        ENDDO
        IF(Ploidy2==2)EXIT
      ENDDO      
      RN = RAN1()
      IF(RN<=PIBD(0))THEN
        DO J2=3,4
          RN = RAN1()
          DO J1=1,NumAllele(J)
            IF(RN<=CP(J1, J))THEN
              IG(J2)=J1
              EXIT
            ENDIF
          ENDDO
          IF(Ploidy2<4)EXIT
        ENDDO      
      ELSEIF(RN<=PIBD(1))THEN 
        IF(Ploidy2==4)THEN
          RN = RAN1()
          DO J1=1,NumAllele(J)
            IF(RN<=CP(J1, J))THEN
              IG(4)=J1
              EXIT
            ENDIF
          ENDDO        
        ENDIF
        IF(Ploidy2>2)THEN
          IG(3)=IG(1+IRBIT())
        ELSE
          IG(3)=IG(1)
        ENDIF
      ELSE   
        IG(3:4)=IG(1:2)
      ENDIF
      DO J1=1,4     
        IF((Ploidy2==3.AND.J1>3).OR.(Ploidy2==2.AND.(J1==2.OR.J1==4)))CYCLE
        RN = RAN1()
        IF(RN<=ErrRate2(J))THEN
          RN = RAN1()
          IG(J1)=NINT((NumAllele(J)-1)*RN)+1
        ENDIF
        IF(J1==2.OR.J1==4) THEN
          IF(IG(J1)<IG(J1-1)) IG(J1-1:J1)=IG(J1:J1-1:-1)
        END IF
      ENDDO
      IF(Ploidy2==2)IG(2)=IG(3)
      IF(MarkerType2(J)==1.OR.Ploidy2==2)THEN
        CALL PHENOTYPE(IG(1),IG(2),IG(3),IG(4),NumAllele(J), &
          ErrRate2(J),P(1:NumAllele(J), J))      
        IF(Ploidy2==4)THEN
          FORALL(J1=1:2) Prob(J1)=TAO(0)+TAO(1)*PHI(J1)+TAO(2)*DELTA(J1)
        ELSEIF(Ploidy2==3)THEN   
          FORALL(J1=1:2) Prob(J1)=TAO(0)+TAO(1)*PHI(J1)
        ELSE
          FORALL(J1=1:2) Prob(J1)=TAO(0)+TAO(1)*DELTA(J1)      
        ENDIF
      ELSE     !Dominant marker
        IF(Ploidy2==4)THEN
          IF(IG(1)==1.AND.IG(2)==1.AND.IG(3)==1.AND.IG(4)==1)THEN
            CALL PHENOTYPE(1,1,1,1,2,ErrRate2(J),P(:2, J))          
            TAO2(0:2)=TAO(0:2)        
          ELSEIF(((IG(1)==2.OR.IG(2)==2).AND.IG(3)==1.AND.IG(4)==1) &
            .OR.((IG(3)==2.OR.IG(4)==2).AND.IG(1)==1.AND.IG(2)==1))THEN
            CALL PHENOTYPE(1,1,1,2,2,ErrRate2(J),P(:2, J)) 
            TAO2(0:2)=TAO(0:2)  
            CALL PHENOTYPE(1,1,2,2,2,ErrRate2(J),P(:2, J)) 
            DO J1=0,2
              TAO2(J1)=2*(TAO2(J1)+TAO(J1))
            ENDDO
          ELSE
            CALL PHENOTYPE(1,2,1,2,2,ErrRate2(J),P(:2, J)) 
            TAO2(0:2)=TAO(0:2)    
            CALL PHENOTYPE(1,2,2,2,2,ErrRate2(J),P(:2, J)) 
            DO J1=0,2
              TAO2(J1)=TAO2(J1)+TAO(J1)*2
            ENDDO     
            CALL PHENOTYPE(2,2,2,2,2,ErrRate2(J),P(:2, J)) 
            DO J1=0,2
              TAO2(J1)=TAO2(J1)+TAO(J1)
            ENDDO        
          ENDIF
          FORALL(J1=1:2) Prob(J1)=TAO2(0)+TAO2(1)*PHI(J1)+TAO2(2)*DELTA(J1)          
        ELSE
          IF(IG(3)==1)THEN
            IF(IG(1)==1.AND.IG(2)==1)THEN
              CALL PHENOTYPE(1,1,1,1,2,ErrRate2(J),P(:2, J)) 
              TAO2(0:1)=TAO(0:1)             
            ELSE
              CALL PHENOTYPE(1,2,1,1,2,ErrRate2(J),P(:2, J)) 
              TAO2(0:1)=TAO(0:1) 
              CALL PHENOTYPE(2,2,1,1,2,ErrRate2(J),P(:2, J)) 
              TAO2(0)=TAO2(0)+TAO(0)
              TAO2(1)=TAO2(1)+TAO(1)                          
            ENDIF
          ELSE
            IF(IG(1)==1.AND.IG(2)==1)THEN
              CALL PHENOTYPE(1,1,2,1,2,ErrRate2(J),P(:2, J)) 
              TAO2(0:1)=TAO(0:1)              
            ELSE
              CALL PHENOTYPE(1,2,2,1,2,ErrRate2(J),P(:2, J)) 
              TAO2(0:1)=TAO(0:1) 
              CALL PHENOTYPE(2,2,2,1,2,ErrRate2(J),P(:2, J)) 
              TAO2(0)=TAO2(0)+TAO(0)
              TAO2(1)=TAO2(1)+TAO(1)             
            ENDIF
          ENDIF
          FORALL(J1=1:2) Prob(J1)=TAO2(0)+TAO2(1)*PHI(J1)          
        ENDIF
      ENDIF     
      X=Prob(1)/Prob(2)
      IF(NSimu==1.AND.List1(I)>1.E306_DP/X)THEN
        List1(I)=1.E306_DP
        EXIT
      ELSE
        List1(I)=List1(I)*X
      ENDIF
    ENDDO         
  ENDDO 
  CALL INDEXX(NPairSimu,List1,INX1) 
  IF(NSimu==1.AND.Maxval(List1)>1.E200_DP)THEN                                            
    CALL SHORTENSimu(NPairSimu,List1,INX1,Prec1,Length2,List2,1)
  ELSE
    CALL SHORTENSimu(NPairSimu,List1,INX1,Prec1,Length2,List2,0)  
  ENDIF      
  IF(NSimu==2)THEN
    RatioMax=List2(Length2,1)
    X=0._DP
    J=Length2
    DO I=Length2,1,-1
      X=X+List2(I,2)
      IF(X>=Sig_Level)THEN
        Y(1,1:2)=(/X,List2(I,1)/)
        J=I
        EXIT
      ENDIF       
    ENDDO         
    IF(J<Length2)THEN
      Y(2,1:2)=(/X-List2(J,2),List2(J+1,1)/) 
      IF(ABS(Y(1,1)-Y(2,1))/Sig_Level<0.05)THEN
        ThreshouldSimu=(Y(1,2)+Y(2,2))/2
      ELSE
        CALL POLINT(Y(:,1),Y(:,2),2,Sig_Level,ThreshouldSimu,X)
      ENDIF       
    ELSE
      ThreshouldSimu=RatioMax+.001
    ENDIF
  ELSE         
    X=0._DP
    J=-1
    DO I=Length2,1,-1
      X=X+List2(I,2)
      IF(List2(I,1)<ThreshouldSimu)THEN
        Y(1,1:2)=(/List2(I,1),X/)
        J=I        
        EXIT
      ENDIF
    ENDDO     
    IF(J/=-1)THEN   
      Y(2,1:2)=(/List2(J+1,1),X-List2(J,2)/)
      CALL POLINT(Y(:,1),Y(:,2),2,ThreshouldSimu,PowerSimu,X)
    ELSE
      PowerSimu=1._DP
    ENDIF
  ENDIF       
END SUBROUTINE SimuGenotype
!
SUBROUTINE SHORTEN(N,List,INX,Prec,I,List2)
USE VARIABLES
INTEGER:: N,INX(N)
REAL(DP):: List(N,3),List2(N,3),Prec,Prec2,X(2),Y 
  Prec2=1._DP+Prec
  Y=List(INX(1),1)*Prec2
  X(:)=List(INX(1),2:3) 
  I=0
  DO JJ=2,N
    J=INX(JJ)
    IF(List(J,1)<=Y.OR.X(2)<1.E-300_DP)THEN
      FORALL(L=1:2)X(L)=X(L)+List(J,L+1)
    ELSE
      I=I+1
      List2(I,:)=(/X(1)/X(2),X(1),X(2)/)
      Y=List(J,1)*Prec2
      X(:)=List(J,2:3)      
    ENDIF
  ENDDO
  IF(X(2)>1.E-300_DP)THEN
    i=i+1
    List2(I,:)=(/X(1)/X(2),X(1),X(2)/)
  ENDIF
END SUBROUTINE SHORTEN

SUBROUTINE SHORTENSimu(N,List,INX,Prec,I,List2,MARK)
USE VARIABLES
INTEGER:: N,INX(N),MARK
REAL(DP):: List(N),List2(N,2),Prec,Prec2,X(2),Y 
  IF(MARK==1)List=List/N
  Prec2=1._DP+Prec     
  X(1:2)=(/List(INX(1)),1._DP/)   
  Y=X(1)*Prec2
  I=0
  DO JJ=2,N
    J=INX(JJ)
    IF(List(J)<=Y)THEN
      X(1)=X(1)+List(J)
      X(2)=X(2)+1._DP
    ELSE
      I=I+1
      List2(I,:)=(/ X(1)/X(2),X(2)/N /)    
      X(1:2)=(/List(J),1._DP/)      
      Y=X(1)*Prec2
    ENDIF
  ENDDO
  i=i+1
  List2(I,:)=(/X(1)/X(2),X(2)/N/)
  IF(MARK==1)List2(:,1)=List2(:,1)*N
END SUBROUTINE SHORTENSimu 

SUBROUTINE LikelihoodRatio(K,E,P,List,Length,MarkerType2)
USE VARIABLES
INTEGER:: Length,K,N,J,J1,J2,J3,J4,MarkerType2
REAL(DP):: P(K),Prob(2),E,TAO2(0:2),List(Length,3)
EXTERNAL:: PHENOTYPE
N=0
IF(Ploidy2==4.AND.MarkerType2==1)THEN      !Diploid-Diploid DYAD, Codominant marker
  DO j1=1,K         
    DO j2=j1,K
      DO j3=J1+1,K         
        DO j4=j3,K                            
          CALL PHENOTYPE(j1,j2,j3,j4,K,E,P)
          FORALL(J=1:2)Prob(J)=TAO(0)+TAO(1)*PHI(J)+TAO(2)*DELTA(J) 
          N=N+1                          
          List(N,:)=(/Prob(1)/Prob(2),Prob(1)+Prob(1),Prob(2)+Prob(2)/)
        ENDDO
      ENDDO              
      DO J4=J2+1,K                 
        CALL PHENOTYPE(j1,j2,j1,j4,K,E,P)
        FORALL(J=1:2)Prob(J)=TAO(0)+TAO(1)*PHI(J)+TAO(2)*DELTA(J) 
        N=N+1
        List(N,:)=(/Prob(1)/Prob(2),Prob(1)+Prob(1),Prob(2)+Prob(2)/)
      ENDDO
      CALL PHENOTYPE(j1,j2,j1,j2,K,E,P)
      FORALL(J=1:2)Prob(J)=TAO(0)+TAO(1)*PHI(J)+TAO(2)*DELTA(J) 
      N=N+1                          
      List(N,:)=(/Prob(1)/Prob(2),Prob(1),Prob(2)/)
    ENDDO
  ENDDO
ELSEIF(Ploidy2==4)THEN  !Diploid-Diploid DYAD, Dominant marker
  DO J=1,3
    IF(J==1)THEN
      CALL PHENOTYPE(1,1,1,1,2,E,P) 
      TAO2(0:2)=TAO(0:2)    
    ELSEIF(J==2)THEN
      CALL PHENOTYPE(1,1,1,2,2,E,P) 
      TAO2(0:2)=TAO(0:2)  
      CALL PHENOTYPE(1,1,2,2,2,E,P) 
      DO J1=0,2
        TAO2(J1)=2*(TAO2(J1)+TAO(J1))
      ENDDO
    ELSE
      CALL PHENOTYPE(1,2,1,2,2,E,P) 
      TAO2(0:2)=TAO(0:2)    
      CALL PHENOTYPE(1,2,2,2,2,E,P) 
      DO J1=0,2
        TAO2(J1)=TAO2(J1)+TAO(J1)*2
      ENDDO     
      CALL PHENOTYPE(2,2,2,2,2,E,P) 
      DO J1=0,2
        TAO2(J1)=TAO2(J1)+TAO(J1)
      ENDDO        
    ENDIF
    FORALL(J2=1:2)Prob(J2)=TAO2(0)+TAO2(1)*PHI(J2)+TAO2(2)*DELTA(J2) 
    N=N+1                          
    List(N,:)=(/Prob(1)/Prob(2),Prob(1),Prob(2)/)  
  ENDDO
ELSEIF(Ploidy2==2.OR.MarkerType2==1)THEN !Diploid-haploid OR Haploid-haploid DYAD 
  DO j1=1,K         
    DO j2=j1,K
      DO j3=1,K
        CALL PHENOTYPE(j1,j2,j3,j3,K,E,P)
        IF(Ploidy2==3)THEN
          FORALL(J=1:2)Prob(J)=TAO(0)+TAO(1)*PHI(J)
        ELSE
          FORALL(J=1:2)Prob(J)=TAO(0)+TAO(1)*DELTA(J)
          IF(J1/=J2)Prob=Prob*2
        ENDIF
        N=N+1
        List(N,:)=(/Prob(1)/Prob(2),Prob(1),Prob(2)/)
        IF(Ploidy2<3) EXIT
      ENDDO
    ENDDO
  ENDDO
ELSE    !Diploid-haploid dyad & Dominant marker
  DO J3=1,2
    DO J1=1,2
      DO J2=J1,2
        CALL PHENOTYPE(j1,j2,j3,j4,2,E,P)
        IF(J1==1)THEN
          TAO2(0:1)=TAO(0:1)
          IF(J2==2)CYCLE
        ELSE
          DO J=0,1
            TAO2(J)=TAO2(J)+TAO(J)
          ENDDO
        ENDIF
        FORALL(J=1:2)Prob(J)=TAO2(0)+TAO2(1)*PHI(J)
        N=N+1
        List(N,:)=(/Prob(1)/Prob(2),Prob(1),Prob(2)/)        
      ENDDO
    ENDDO             
  ENDDO
ENDIF
END SUBROUTINE LikelihoodRatio   

SUBROUTINE RelatednessInfor(K,E,P,RInfor,MarkerType2)   
USE VARIABLES
INTEGER:: K,J,J1,J2,J3,J4,MarkFunc,MARKDH,MarkerType2
REAL(DP):: P(K),E,RInfor,gammln,TAO2(0:2)
REAL(DP):: coef,x1,SS,RInforFuncH,RInforFDH
INTEGER,PARAMETER:: LW=1600,LIW=LW/4
COMMON /xy/coef,x1,MarkFunc,MARKDH
EXTERNAL RInforFuncH,qromb,RInforFDH,gammln,PHENOTYPE
IF(Ploidy2==4)THEN      !Diploid-Diploid DYAD
  coef=exp(gammln(BETA(3))-gammln(BETA(2))-gammln(BETA(1))-gammln(BETA(0)))
  MarkFunc=0 
  CALL qromb(RInforFuncH,0._DP,1._DP,SS)
  MarkFunc=1
  RInfor=-SS
  IF(MarkerType2==1)THEN  !Codominant marker
    DO j1=1,K         
      DO j2=j1,K
        DO j3=J1+1,K         
          DO j4=j3,K    
            CALL PHENOTYPE(j1,j2,j3,j4,K,E,P)      
            CALL qromb(RInforFuncH,0._DP,1._DP,SS)
            RInfor=RInfor+2*SS
          ENDDO
        ENDDO           
        DO J4=J2+1,K   
          CALL PHENOTYPE(j1,j2,j1,j4,K,E,P)                       
          CALL qromb(RInforFuncH,0._DP,1._DP,SS)
          RInfor=RInfor+2*SS
        ENDDO  
        CALL PHENOTYPE(j1,j2,j1,j2,K,E,P)   
        CALL qromb(RInforFuncH,0._DP,1._DP,SS)
        RInfor=RInfor+SS 
      ENDDO
    ENDDO
  ELSE                  !Dominant marker
    DO J=1,3
      IF(J==1)THEN
        CALL PHENOTYPE(1,1,1,1,2,E,P)      
      ELSEIF(J==2)THEN
        CALL PHENOTYPE(1,1,1,2,2,E,P) 
        TAO2(0:2)=TAO(0:2)  
        CALL PHENOTYPE(1,1,2,2,2,E,P) 
        DO J1=0,2
          TAO(J1)=2*(TAO2(J1)+TAO(J1))
        ENDDO
      ELSE
        CALL PHENOTYPE(1,2,1,2,2,E,P) 
        TAO2(0:2)=TAO(0:2)    
        CALL PHENOTYPE(1,2,2,2,2,E,P) 
        DO J1=0,2
          TAO2(J1)=TAO2(J1)+TAO(J1)*2
        ENDDO     
        CALL PHENOTYPE(2,2,2,2,2,E,P) 
        DO J1=0,2
          TAO(J1)=TAO2(J1)+TAO(J1)
        ENDDO        
      ENDIF  
      CALL qromb(RInforFuncH,0._DP,1._DP,SS)
      RInfor=RInfor+SS 
    ENDDO      
  ENDIF
ELSE                    !Diploid-haploid or Haploid-haploid DYAD
  IF(Ploidy2==3)THEN
    MARKDH=1
    J4=K
  ELSE
    MARKDH=2
    J4=1
  ENDIF
  coef=exp(gammln(BETA(3))-gammln(BETA(MARKDH))-gammln(BETA(0)))
  MarkFunc=0 
  CALL qromb(RInforFDH,0._DP,1._DP,SS)
  MarkFunc=1
  RInfor=-SS
  IF(MarkerType2==1.OR.Ploidy2==2)THEN  !Codominant marker  
    DO j1=1,K         
      DO j2=j1,K
        DO j3=1,J4
          CALL PHENOTYPE(j1,j2,j3,j4,K,E,P)  
          CALL qromb(RInforFDH,0._DP,1._DP,SS)
          RInfor=RInfor+SS
          IF(MARKDH==2.AND.J1/=J2)RInfor=RInfor+SS
        ENDDO
      ENDDO
    ENDDO   
  ELSE                                  !Diploid-Haploid dyad, Dominant marker
    DO J3=1,2
      DO J1=1,2
        DO J2=J1,2
          CALL PHENOTYPE(j1,j2,j3,j4,K,E,P)
          IF(J1==1)THEN
            IF(J2==2)THEN
              TAO2(0:1)=TAO(0:1)
              CYCLE
            ENDIF
          ELSE
            DO J=0,1
              TAO(J)=TAO2(J)+TAO(J)
            ENDDO
          ENDIF
          CALL qromb(RInforFDH,0._DP,1._DP,SS)        
          RInfor=RInfor+SS
        ENDDO
      ENDDO             
    ENDDO 
  ENDIF
ENDIF 
END SUBROUTINE RelatednessInfor   

FUNCTION RInforFDH(X2)   !Diploid-Haploid dyad
USE VARIABLES  
INTEGER:: MarkFunc,MARKDH
REAL(DP):: RInforFDH,coef,x2,x1,x0,FF
COMMON /xy/coef,x1,MarkFunc,MARKDH
  x0=1._DP-x2
  IF(x0<TINY)Then
    FF=0._DP
  ELSE
    FF=coef
    IF(abs(BETA(MARKDH)-1._DP)>TINY) FF=coef*X2**(BETA(MARKDH)-1._DP)    
    IF(abs(BETA(0)-1._DP)>TINY) FF=FF*x0**(BETA(0)-1._DP)
  ENDIF    
  IF(MarkFunc==0)THEN
    IF(FF>0._DP)then
      RInforFDH=FF*Log(FF)
    else
      RInforFDH=0._DP
    endif   
    RETURN  
  ELSE
    X0=(TAO(0)+TAO(1)*X2)*FF
    IF(X0>TINY)THEN
      RInforFDH=X0*Log(X0/(TAO(0)+BETA(MARKDH)*TAO(1)/(BETA(3))))
    ELSE
      RInforFDH=0._DP
    ENDIF
  ENDIF
END FUNCTION RInforFDH

FUNCTION RInforFuncf(X2)
USE VARIABLES  
INTEGER:: MarkFunc,MARKDH
REAL(DP):: RInforFuncf,coef,x2,x1,x0,FF
COMMON /xy/coef,x1,MarkFunc,MARKDH  
  x0=1._DP-x2-x1 
  IF(x0<TINY)Then
    FF=0._DP
  ELSE                              
    FF=coef
    IF(abs(BETA(2)-1._DP)>TINY) FF=FF*X2**(BETA(2)-1._DP)
    IF(abs(BETA(1)-1._DP)>TINY) FF=FF*X1**(BETA(1)-1._DP)  
    IF(abs(BETA(0)-1._DP)>TINY) FF=FF*x0**(BETA(0)-1._DP)
  ENDIF    
  IF(MarkFunc==0)THEN
    IF(FF>0._DP)then
      RInforFuncf=FF*Log(FF)
    else
      RInforFuncf=0._DP
    endif   
    RETURN  
  ELSE
    X0=(TAO(0)+TAO(1)*X1+TAO(2)*X2)*FF
    IF(X0>TINY)THEN
      RInforFuncf=X0*(Log(X0)-LOG((BETA(0)*TAO(0)+BETA(1)* &
         (TAO(0)+TAO(1))+BETA(2)*(TAO(0)+TAO(2)))/BETA(3)))
    ELSE
      RInforFuncf=0._DP
    ENDIF
  ENDIF
END FUNCTION RInforFuncf

FUNCTION RInforFuncH(XX)
USE VARIABLES  
INTEGER:: MarkFunc,MARKDH
REAL(DP):: coef,x1,XX,RInforFuncH,RInforFuncf, Y
COMMON /xy/coef,x1,MarkFunc,MARKDH
EXTERNAL:: RInforFuncf,QSimp
  X1=XX
  CALL QSimp(RInforFuncF, 0._DP, 1._DP - X1, Y)
  RInforFuncH = Y
END FUNCTION RInforFuncH
!
SUBROUTINE qsimp(func,a,b,s)
  USE VARIABLES, ONLY : DP
  INTEGER JMAX
  REAL(DP) :: a,b,func,s,EPS
  EXTERNAL func
  PARAMETER (EPS=1.e-2_DP, JMAX=20)
  INTEGER j
  REAL(DP) :: os,ost,st
  ost=-1.e30_DP
  os= -1.e30_DP
  do j=1,JMAX
    call trapzd(func,a,b,st,j)
    s=(4._DP*st-ost)/3._DP
    if (j > 5) then
      if (abs(s-os).lt.EPS*abs(os).or.(s.eq.0._DP.and.os.eq.0._DP)) return
    endif
    os=s
    ost=st
  END DO
END SUBROUTINE qsimp
!
FUNCTION gammln(xx)
INTEGER j
DOUBLE PRECISION ser,stp,tmp,x,y,cof(6),gammln,xx
SAVE cof,stp
DATA cof,stp/76.18009172947146d0,-86.50532032941677d0, &
   24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2, &
   -.5395239384953d-5,2.5066282746310005d0/
  x=xx
  y=x
  tmp=x+5.5d0
  tmp=(x+0.5d0)*log(tmp)-tmp
  ser=1.000000000190015d0
  do j=1,6
    y=y+1.d0
    ser=ser+cof(j)/y
  enddo
  gammln=tmp+log(stp*ser/x)
END FUNCTION gammln
!
SUBROUTINE indexx(n,arr,indx)
USE VARIABLES
INTEGER:: n,indx(n),M,NSTACK
REAL(DP):: arr(n),A
PARAMETER (M=7,NSTACK=50)
INTEGER:: i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
  FORALL(j=1:n) indx(j)=j
  jstack=0
  l=1
  ir=n
  Loop0: DO
    if(ir-l.lt.M)then
      Loop1: do j=l+1,ir
        indxt=indx(j)
        a=arr(indxt)
        Loop11: do i=j-1,l,-1
          IF(arr(indx(i)).le.a)THEN
            indx(i+1)=indxt
            CYCLE Loop1
          ENDIF
          indx(i+1)=indx(i)
        ENDDO Loop11 
        i=l-1
        indx(i+1)=indxt
      ENDDO Loop1
      if(jstack.eq.0)return
      ir=istack(jstack)
      l=istack(jstack-1)
      jstack=jstack-2
    else
      k=(l+ir)/2
      itemp=indx(k)
      indx(k)=indx(l+1)
      indx(l+1)=itemp
      if(arr(indx(l)).gt.arr(indx(ir)))then
        itemp=indx(l)
        indx(l)=indx(ir)
        indx(ir)=itemp
      endif
      if(arr(indx(l+1)).gt.arr(indx(ir)))then
        itemp=indx(l+1)
        indx(l+1)=indx(ir)
        indx(ir)=itemp
      endif
      if(arr(indx(l)).gt.arr(indx(l+1)))then
        itemp=indx(l)
        indx(l)=indx(l+1)
        indx(l+1)=itemp
      endif
      i=l+1
      j=ir
      indxt=indx(l+1)
      a=arr(indxt)
      Loop3: DO
        i=i+1
        if(arr(indx(i)).lt.a)CYCLE Loop3
        Loop4: DO
          j=j-1
          if(arr(indx(j))<=a)EXIT Loop4
        ENDDO Loop4
        if(j.lt.i)EXIT Loop3
        itemp=indx(i)
        indx(i)=indx(j)
        indx(j)=itemp
      ENDDO Loop3
      indx(l+1)=indx(j)
      indx(j)=indxt
      jstack=jstack+2
      if(jstack.gt.NSTACK)THEN
        WRITE(*, *) 'NSTACK too small in indexx'
        CALL DelayedExit(1.0)
      end if
      if(ir-i+1.ge.j-l)then
        istack(jstack)=ir
        istack(jstack-1)=i
        ir=j-1
      else
        istack(jstack)=j-1
        istack(jstack-1)=l
        l=i
      endif
    endif
  ENDDO Loop0
END SUBROUTINE INDEXX

SUBROUTINE qromb(func,a,b,ss)
  USE VARIABLES
  IMPLICIT NONE
  INTEGER JMAX,JMAXP,K,KM
  REAL(DP) :: a,b,func,ss,EPS
  EXTERNAL func
  PARAMETER (EPS=1.e-6_DP, JMAX=20, JMAXP=JMAX+1, K=5, KM=K-1)
  INTEGER j
  REAL(DP) :: dss,h(JMAXP),s(JMAXP)
  h(1)=1._DP
  do j=1,JMAX
    call trapzd(func,a,b,s(j),j)
    if (j.ge.K) then
      call polint(h(j-KM),s(j-KM),K,0._DP,ss,dss)
      if (abs(dss).le.EPS*abs(ss)) return
    endif
    s(j+1)=s(j)
    h(j+1)=0.25_DP*h(j)
  end do
END SUBROUTINE qromb

SUBROUTINE trapzd(func,a,b,s,n)
  USE VARIABLES
  IMPLICIT NONE
  INTEGER n
  REAL(DP) :: a,b,s,func
  EXTERNAL func
  INTEGER it,j
  REAL(DP) :: del,sum,tnm,x
  if (n==1) then
    s=0.5_DP*(b-a)*(func(a)+func(b))
  else
    it=2**(n-2)
    tnm=it
    del=(b-a)/tnm
    x=a+0.5*del
    sum=0._DP
    do j=1,it
      sum=sum+func(x)
      x=x+del
    end do
    s=0.5_DP*(s+(b-a)*sum/tnm)
  endif
END SUBROUTINE trapzd

SUBROUTINE polint(xa,ya,n,x,y,dy)
USE VARIABLES
INTEGER n,NMAX
REAL(DP):: dy,x,y,xa(n),ya(n)
PARAMETER (NMAX=10)
INTEGER i,m,ns
REAL(DP):: den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
  ns=1
  dif=abs(x-xa(1))
  DO i=1,n
    dift=abs(x-xa(i))
    if (dift.lt.dif) then
      ns=i
      dif=dift
    endif
    c(i)=ya(i)
    d(i)=ya(i)
  ENDDO
  y=ya(ns)
  ns=ns-1
  DO m=1,n-1
    DO i=1,n-m
      ho=xa(i)-x
      hp=xa(i+m)-x
      w=c(i+1)-d(i)
      den=ho-hp
      if(ABS(den)<1.E-100_DP)then
        WRITE(*, *) 'failure in polint'
        CALL DelayedExit(1.0)
      end if        
      den=w/den
      d(i)=hp*den
      c(i)=ho*den     
    ENDDO
    if (2*ns.lt.n-m)then
      dy=c(ns+1)
    else
      dy=d(ns)
      ns=ns-1
    endif
    y=y+dy
  ENDDO
END SUBROUTINE polint
!
FUNCTION irbit()
  use variables
  INTEGER irbit,IB1,IB2,IB5,IB18
  INTEGER,SAVE:: iseed 
  PARAMETER (IB1=1,IB2=2,IB5=16,IB18=131072)
  LOGICAL newbit
  DATA iseed/12345/
  newbit=iand(iseed,IB18)/=0
  if(iand(iseed,IB5)/=0)newbit=.not.newbit
  if(iand(iseed,IB2)/=0)newbit=.not.newbit
  if(iand(iseed,IB1)/=0)newbit=.not.newbit
  irbit=0
  iseed=iand(ishft(iseed,1),not(IB1))
  if(newbit)then
    irbit=1
    iseed=ior(iseed,IB1)
  endif
END FUNCTION IRBIT
!
      SUBROUTINE spear(data1,data2,n,wksp1,wksp2,d,zd,probd,rs,probrs)
      INTEGER,PARAMETER:: DP=SELECTED_REAL_KIND(P=13)      
      INTEGER n
      REAL(DP):: d,probd,probrs,rs,zd,data1(n),data2(n),wksp1(n),wksp2(n)
!    USES betai,crank,erfcc,sort2
      INTEGER j
      REAL(DP):: aved,df,en,en3n,fac,sf,sg,t,vard,betai,erfcc
      do 11 j=1,n
        wksp1(j)=data1(j)
        wksp2(j)=data2(j)
11    continue
      call sort2(n,wksp1,wksp2)
      call crank(n,wksp1,sf)
      call sort2(n,wksp2,wksp1)
      call crank(n,wksp2,sg)
      d=0.
      do 12 j=1,n
        d=d+(wksp1(j)-wksp2(j))**2
12    continue
      en=n
      en3n=en**3-en
      aved=en3n/6.-(sf+sg)/12.
      fac=(1.-sf/en3n)*(1.-sg/en3n)
      vard=((en-1.)*en**2*(en+1.)**2/36.)*fac
      zd=(d-aved)/sqrt(vard)
      probd=erfcc(abs(zd)/1.4142136)
      rs=(1.-(6./en3n)*(d+(sf+sg)/12.))/sqrt(fac)
      fac=(1.+rs)*(1.-rs)
      if(fac.gt.0.)then
        t=rs*sqrt((en-2.)/fac)
        df=en-2.
        probrs=betai(0.5_DP*df,0.5_DP,df/(df+t**2))
      else
        probrs=0.
      endif
      END

      SUBROUTINE crank(n,w,s)
      INTEGER,PARAMETER:: DP=SELECTED_REAL_KIND(P=13)      
      INTEGER n
      REAL(DP):: s,w(n)
      INTEGER j,ji,jt
      REAL(DP):: rank,t
      s=0.
      j=1
1     if(j.lt.n)then
        if(ABS(w(j+1)-w(j))>1.E-300_DP)then
          w(j)=j
          j=j+1
        else
          do 11 jt=j+1,n
            if(ABS(w(jt)-w(j))>1.E-300_DP)goto 2
11        continue
          jt=n+1
2         rank=0.5*(j+jt-1)
          do 12 ji=j,jt-1
            w(ji)=rank
12        continue
          t=jt-j
          s=s+t**3-t
          j=jt
        endif
      goto 1
      endif
      if(j.eq.n)w(n)=n
      END

      SUBROUTINE sort2(n,arr,brr)
      INTEGER,PARAMETER:: DP=SELECTED_REAL_KIND(P=13)      
      INTEGER n,M,NSTACK
      REAL(DP):: arr(n),brr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,ir,j,jstack,k,l,istack(NSTACK)
      REAL(DP):: a,b,temp
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 12 j=l+1,ir
          a=arr(j)
          b=brr(j)
          do 11 i=j-1,l,-1
            if(arr(i).le.a)goto 2
            arr(i+1)=arr(i)
            brr(i+1)=brr(i)
11        continue
          i=l-1
2         arr(i+1)=a
          brr(i+1)=b
12      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        temp=arr(k)
        arr(k)=arr(l+1)
        arr(l+1)=temp
        temp=brr(k)
        brr(k)=brr(l+1)
        brr(l+1)=temp
        if(arr(l).gt.arr(ir))then
          temp=arr(l)
          arr(l)=arr(ir)
          arr(ir)=temp
          temp=brr(l)
          brr(l)=brr(ir)
          brr(ir)=temp
        endif
        if(arr(l+1).gt.arr(ir))then
          temp=arr(l+1)
          arr(l+1)=arr(ir)
          arr(ir)=temp
          temp=brr(l+1)
          brr(l+1)=brr(ir)
          brr(ir)=temp
        endif
        if(arr(l).gt.arr(l+1))then
          temp=arr(l)
          arr(l)=arr(l+1)
          arr(l+1)=temp
          temp=brr(l)
          brr(l)=brr(l+1)
          brr(l+1)=temp
        endif
        i=l+1
        j=ir
        a=arr(l+1)
        b=brr(l+1)
3       continue
          i=i+1
        if(arr(i).lt.a)goto 3
4       continue
          j=j-1
        if(arr(j).gt.a)goto 4
        if(j.lt.i)goto 5
        temp=arr(i)
        arr(i)=arr(j)
        arr(j)=temp
        temp=brr(i)
        brr(i)=brr(j)
        brr(j)=temp
        goto 3
5       arr(l+1)=arr(j)
        arr(j)=a
        brr(l+1)=brr(j)
        brr(j)=b
        jstack=jstack+2
        if(jstack.gt.NSTACK)THEN
          WRITE(*, *) 'NSTACK too small in sort2'
          CALL DelayedExit(1.0)
        end if
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END
!
      FUNCTION betai(a,b,x)
      INTEGER,PARAMETER:: DP=SELECTED_REAL_KIND(P=13)          
      REAL(DP):: betai,a,b,x
      REAL(DP):: bt,betacf,gammln
      if(x.lt.0..or.x.gt.1.) THEN
        WRITE(*, *) 'bad argument x in betai'
        CALL DelayedExit(1.0)
      end if
      if(abs(x)<1.e-300_DP.or.abs(x-1._DP)<1.e-300_DP)then      
        bt=0.
      else
        bt=exp(gammln(a+b)-gammln(a)-gammln(b)+a*log(x)+b*log(1.-x))
      endif
      if(x.lt.(a+1.)/(a+b+2.))then
        betai=bt*betacf(a,b,x)/a
        return
      else
        betai=1.-bt*betacf(b,a,1.-x)/b
        return
      endif
      END   
!
      FUNCTION erfcc(x)
      INTEGER,PARAMETER:: DP=SELECTED_REAL_KIND(P=13)         
      REAL(DP):: erfcc,x,t,z
      z=abs(x)
      t=1./(1.+0.5*z)
      erfcc=t*exp(-z*z-1.26551223+t*(1.00002368+t*(.37409196+t*  &
        (.09678418+t*(-.18628806+t*(.27886807+t*(-1.13520398+t*    &
        (1.48851587+t*(-.82215223+t*.17087277)))))))))
      if (x.lt.0.) erfcc=2.-erfcc
      END     
!
      FUNCTION betacf(a,b,x)
      INTEGER,PARAMETER:: DP=SELECTED_REAL_KIND(P=13)               
      INTEGER MAXIT
      REAL(DP):: betacf,a,b,x,EPS,FPMIN
      PARAMETER (MAXIT=100,EPS=3.e-7_DP,FPMIN=1.e-30_DP)
      INTEGER m,m2
      REAL(DP):: aa,c,d,del,h,qab,qam,qap
      qab=a+b
      qap=a+1.
      qam=a-1.
      c=1.
      d=1.-qab*x/qap
      if(abs(d).lt.FPMIN)d=FPMIN
      d=1./d
      h=d
      do 11 m=1,MAXIT
        m2=2*m
        aa=m*(b-m)*x/((qam+m2)*(a+m2))
        d=1.+aa*d
        if(abs(d).lt.FPMIN)d=FPMIN
        c=1.+aa/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        h=h*d*c
        aa=-(a+m)*(qab+m)*x/((a+m2)*(qap+m2))
        d=1.+aa*d
        if(abs(d).lt.FPMIN)d=FPMIN
        c=1.+aa/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        del=d*c
        h=h*del
        if(abs(del-1.).lt.EPS)goto 1
11    continue
      WRITE(*, *) 'a or b too big, or MAXIT too small in betacf'
      CALL DelayedExit(1.0)
1     betacf=h
      return
      END
!
FUNCTION Ran1()
  Use Variables, Only : IDUM
  IMPLICIT NONE
  INTEGER, PARAMETER :: K4B=selected_int_kind(9)
  REAL :: Ran1
  INTEGER(K4B), PARAMETER :: IA=16807,IM=2147483647,IQ=127773,IR=2836
  REAL, SAVE :: am
  INTEGER(K4B), SAVE :: ix=-1,iy=-1,k
  if (idum <= 0 .or. iy < 0) then
      am=nearest(1.0,-1.0)/Real(IM)
      iy=ior(ieor(888889999,abs(idum)),1)
      ix=ieor(777755555,abs(idum))
      idum=abs(idum)+1
  end if
  ix=ieor(ix,ishft(ix,13))
  ix=ieor(ix,ishft(ix,-17))
  ix=ieor(ix,ishft(ix,5))
  k=iy/IQ
  iy=IA*(iy-k*IQ)-IR*k
  if (iy < 0) iy=iy+IM
  Ran1=am*ior(iand(IM,ieor(ix,iy)),1)
END FUNCTION Ran1                